#ifndef PN_EXCEPTION_H
#define PN_EXCEPTION_H

#include <iostream>

class PN_Exception
{
    public:
        /** Default constructor */
        PN_Exception();
        /** Default destructor */
        virtual ~PN_Exception();
        virtual void Print() {std::cout << "PN Exception: ";}
};

class PN_Error_Exception : public PN_Exception
{
    public:
        PN_Error_Exception(std::string errMsg) : PN_Exception() {msg = errMsg;}
        virtual ~PN_Error_Exception();
        virtual void Print()
        {
            PN_Exception::Print();
            std::cout << msg;
        }
        std::string msg;
};
#endif // PN_EXCEPTION_H
