#include "PerformanceTest01.h"

PN_MetaClass *PerformanceTest01::GetInstantiator()
{
	return new PN_MetaClass_PerformanceTest01();
}

PerformanceTest01::PerformanceTest01()
{
	// ------------------places init----------------
	PN_Multiset *start_Multiset = new PN_Multiset();
	start_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	start = new PN_Place(start_Multiset, "start");

	delete start_Multiset;
	end = new PN_Place("end");

	PN_Multiset *inv_Multiset = new PN_Multiset();
	inv_Multiset->AddItem(new PN_MultiItemInt(1, 0));
	inv = new PN_Place(inv_Multiset, "inv");

	delete inv_Multiset;
	// ----------------transitions init---------------
//-----------------transition t1 init-----------------
	PN_Transition *t1 = new PN_Transition("t1");
	this->RegisterTransition(t1);

	// ---------preconds-------
	list<PN_Condition *> t1_precond;

	PN_Multiset *t1_precondstart_Multiset = new PN_Multiset();
	t1_precondstart_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	t1_precond.push_back(new PN_Condition(start, t1_precondstart_Multiset));
	t1->SetPreconds(t1_precond);

	// ---------postconds-------
	list<PN_Condition *> t1_postcond;

	PN_Multiset *t1_postcondend_Multiset = new PN_Multiset();
	t1_postcondend_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	t1_postcond.push_back(new PN_Condition(end, t1_postcondend_Multiset));
	t1->SetPostconds(t1_postcond);

	// ---------action-------
	PN_Expression *t1_action_1;
	PN_MessageKeys *t1_action_1_key = new PN_MessageKeys("show:");
	t1_action_1_key->keys.push_back(new PN_Operand_Token(new StringToken("*** start")));
	t1_action_1 = new PN_Expression(t1_action_1_key, new PN_Operand_Token(Transcript::GetInstantiator()));
	t1_action_1->AddResultVar("__primary__");
	t1->AddAction(t1_action_1);

	PN_Expression *t1_action_2;
	t1_action_2 = new PN_Expression(new PN_MessageUnary("millisecondClockValue"), new PN_Operand_Token(Time::GetInstantiator()));
	t1_action_2->AddResultVar("__primary__");
	t1->AddAction(t1_action_2);

	PN_Expression *t1_action_3;
	t1_action_3 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_3->AddResultVar("t1");
	t1->AddAction(t1_action_3);

	PN_Expression *t1_action_4;
	t1_action_4 = new PN_Expression(NULL, new PN_Operand_Token(new IntToken(0)));
	t1_action_4->AddResultVar("n");
	t1->AddAction(t1_action_4);

	PN_Expression *t1_action_5;
	t1_action_5 = new PN_Expression(new PN_MessageUnary("go"), new PN_Operand_Token(new PNToken(this->GetSelf())));
	t1_action_5->AddResultVar("__primary__");
	t1->AddAction(t1_action_5);

	PN_Expression *t1_action_6;
	t1_action_6 = new PN_Expression(new PN_MessageUnary("millisecondClockValue"), new PN_Operand_Token(Time::GetInstantiator()));
	t1_action_6->AddResultVar("__primary__");
	t1->AddAction(t1_action_6);

	PN_Expression *t1_action_7;
	t1_action_7 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_7->AddResultVar("t2");
	t1->AddAction(t1_action_7);

	PN_Expression *t1_action_8;
	t1_action_8 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Var("t1")), new PN_Operand_Var("t2"));
	t1_action_8->AddResultVar("_____primary__");
	t1->AddAction(t1_action_8);

	PN_Expression *t1_action_9;
	t1_action_9 = new PN_Expression(NULL, new PN_Operand_Var("_____primary__"));
	t1_action_9->AddResultVar("____primary__");
	t1->AddAction(t1_action_9);

	PN_Expression *t1_action_10;
	t1_action_10 = new PN_Expression(new PN_MessageUnary("printString"), new PN_Operand_Var("____primary__"));
	t1_action_10->AddResultVar("____primary__");
	t1->AddAction(t1_action_10);

	PN_Expression *t1_action_11;
	t1_action_11 = new PN_Expression(NULL, new PN_Operand_Var("____primary__"));
	t1_action_11->AddResultVar("___binArg__");
	t1->AddAction(t1_action_11);

	PN_Expression *t1_action_12;
	t1_action_12 = new PN_Expression(new PN_MessageBin(",", new PN_Operand_Var("___binArg__")), new PN_Operand_Token(new StringToken("*** end: ")));
	t1_action_12->AddResultVar("___primary__");
	t1->AddAction(t1_action_12);

	PN_Expression *t1_action_13;
	t1_action_13 = new PN_Expression(NULL, new PN_Operand_Var("___primary__"));
	t1_action_13->AddResultVar("__key0__");
	t1->AddAction(t1_action_13);

	PN_Expression *t1_action_14;
	PN_MessageKeys *t1_action_14_key = new PN_MessageKeys("show:");
	t1_action_14_key->keys.push_back(new PN_Operand_Var("__key0__"));
	t1_action_14 = new PN_Expression(t1_action_14_key, new PN_Operand_Token(Transcript::GetInstantiator()));
	t1_action_14->AddResultVar("__primary__");
	t1->AddAction(t1_action_14);

//-----------------transition t2 init-----------------
	PN_Transition *t2 = new PN_Transition("t2");
	this->RegisterTransition(t2);

	// ---------preconds-------
	list<PN_Condition *> t2_precond;

	PN_Multiset *t2_precondend_Multiset = new PN_Multiset();
	t2_precondend_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	t2_precond.push_back(new PN_Condition(end, t2_precondend_Multiset));
	t2->SetPreconds(t2_precond);

	// -----------conds-------
	list<PN_Condition *> t2_cond;

	PN_Multiset *t2_condinv_Multiset = new PN_Multiset();
	t2_condinv_Multiset->AddItem(new PN_MultiItemVariable(1, "n"));
	t2_cond.push_back(new PN_Condition(inv, t2_condinv_Multiset));
	t2->SetConds(t2_cond);

	// ---------action-------
	PN_Expression *t2_action_1;
	t2_action_1 = new PN_Expression(new PN_MessageUnary("printString"), new PN_Operand_Var("n"));
	t2_action_1->AddResultVar("____primary__");
	t2->AddAction(t2_action_1);

	PN_Expression *t2_action_2;
	t2_action_2 = new PN_Expression(NULL, new PN_Operand_Var("____primary__"));
	t2_action_2->AddResultVar("___binArg__");
	t2->AddAction(t2_action_2);

	PN_Expression *t2_action_3;
	t2_action_3 = new PN_Expression(new PN_MessageBin(",", new PN_Operand_Var("___binArg__")), new PN_Operand_Token(new StringToken("*** pocet volani: ")));
	t2_action_3->AddResultVar("___primary__");
	t2->AddAction(t2_action_3);

	PN_Expression *t2_action_4;
	t2_action_4 = new PN_Expression(NULL, new PN_Operand_Var("___primary__"));
	t2_action_4->AddResultVar("__key0__");
	t2->AddAction(t2_action_4);

	PN_Expression *t2_action_5;
	PN_MessageKeys *t2_action_5_key = new PN_MessageKeys("show:");
	t2_action_5_key->keys.push_back(new PN_Operand_Var("__key0__"));
	t2_action_5 = new PN_Expression(t2_action_5_key, new PN_Operand_Token(Transcript::GetInstantiator()));
	t2_action_5->AddResultVar("__primary__");
	t2->AddAction(t2_action_5);

	//-------------------- sync ports -----------------------------
//------------------------ port get1: -----------------------------
	list<string> get1__args = list<string>();
	get1__args.push_back("n");
	get1_ = new PN_SyncPort(get1__args, "get1:");

	// ---------preconds-------
	list<PN_Condition *> get1__precond;

	PN_Multiset *get1__precondinv_Multiset = new PN_Multiset();
	get1__precondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "n"));
	get1__precond.push_back(new PN_Condition(inv, get1__precondinv_Multiset));
	get1_->SetPreconds(get1__precond);

//------------------------ port get2: -----------------------------
	list<string> get2__args = list<string>();
	get2__args.push_back("n");
	get2_ = new PN_SyncPort(get2__args, "get2:");

	// ---------preconds-------
	list<PN_Condition *> get2__precond;

	PN_Multiset *get2__precondinv_Multiset = new PN_Multiset();
	get2__precondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "n"));
	get2__precond.push_back(new PN_Condition(inv, get2__precondinv_Multiset));
	get2_->SetPreconds(get2__precond);

//------------------------ port put: -----------------------------
	list<string> put__args = list<string>();
	put__args.push_back("n");
	put_ = new PN_SyncPort(put__args, "put:");

	// ---------postconds-------
	list<PN_Condition *> put__postcond;

	PN_Multiset *put__postcondinv_Multiset = new PN_Multiset();
	put__postcondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "n"));
	put__postcond.push_back(new PN_Condition(inv, put__postcondinv_Multiset));
	put_->SetPostconds(put__postcond);

}

PerformanceTest01::~PerformanceTest01()
{
	start->Clear();
	delete start;
	end->Clear();
	delete end;
	inv->Clear();
	delete inv;
}

PN_Place *PerformanceTest01::GetPlace(string placeName)
{
	if (placeName == "start")
		return start;
	else if (placeName == "end")
		return end;
	else if (placeName == "inv")
		return inv;
	else 
		return NULL;
}

Token* PerformanceTest01::SendMessage(string message, list<PN_Operand*>& args, list<PN_Binding>& binds)
{
	if(message == "get1:")
	{
		return new BoolToken(get1_->Execute(args, binds));
	}
	if(message == "get2:")
	{
		return new BoolToken(get2_->Execute(args, binds));
	}
	if(message == "put:")
	{
		return new BoolToken(put_->Execute(args, binds));
	}
	if(message == "go" )
	{
		PN_Operand *op;
		if (args.size() < 0)
		{
			throw new PN_NotEnoughArguments("PerformanceTest01", "go", 0, args.size());
		}
		throw new PN_MethodForkException(new PerformanceTest01_go(this));
	}
	return PN_Class::SendMessage(message, args, binds);
}

Token* PerformanceTest01::SimulateMessage(string message, list<PN_Operand*>& args, list<PN_Binding>& binds)
{
	if(message == "get1:")
	{
		return new BoolToken(get1_->TryBind(args, binds));
	}
	if(message == "get2:")
	{
		return new BoolToken(get2_->TryBind(args, binds));
	}
	if(message == "put:")
	{
		return new BoolToken(put_->TryBind(args, binds));
	}
	return PN_Class::SimulateMessage(message, args, binds);
}


PerformanceTest01_go::PerformanceTest01_go(PN_Class *parentObj)
	:PN_Method_Net(parentObj){
	// ------------------places init----------------
	PN_Multiset *s_Multiset = new PN_Multiset();
	s_Multiset->AddItem(new PN_MultiItemInt(1, 10000));
	s = new PN_Place(s_Multiset, "s");

	delete s_Multiset;
	_return = new PN_Place_Return(this);

	p = new PN_Place("p");

	// ----------------transitions init---------------
//-----------------transition t1 init-----------------
	PN_Transition *t1 = new PN_Transition("t1");
	this->RegisterTransition(t1);

	// ---------preconds-------
	list<PN_Condition *> t1_precond;

	PN_Multiset *t1_preconds_Multiset = new PN_Multiset();
	t1_preconds_Multiset->AddItem(new PN_MultiItemVariable(1, "it"));
	t1_precond.push_back(new PN_Condition(s, t1_preconds_Multiset));
	t1->SetPreconds(t1_precond);

	// ---------postconds-------
	list<PN_Condition *> t1_postcond;

	PN_Multiset *t1_postcondp_Multiset = new PN_Multiset();
	{
		PN_MultiItemList *multiList1 = new PN_MultiItemList(1);
		multiList1->AddItem(new PN_MultiItemVariable(1, "itt"));
		multiList1->AddItem(new PN_MultiItemVariable(1, "xx"));
		t1_postcondp_Multiset->AddItem(multiList1);
	}
	t1_postcond.push_back(new PN_Condition(p, t1_postcondp_Multiset));
	t1->SetPostconds(t1_postcond);

	// --------- guard -------
	PN_Guard *t1_guard_1 = new PN_Guard();
	PN_Expression *t1_guard_1_expr_1;
	t1_guard_1_expr_1 = new PN_Expression(new PN_MessageBin(">", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("it"));
	t1_guard_1->AddExpr(t1_guard_1_expr_1);
	t1->SetGuard(t1_guard_1);

	PN_Guard *t1_guard_2 = new PN_Guard();
	PN_Expression *t1_guard_2_expr_1;
	PN_MessageKeys *t1_guard_2_expr_1_key = new PN_MessageKeys("get1:");
	t1_guard_2_expr_1_key->keys.push_back(new PN_Operand_Var("x"));
	t1_guard_2_expr_1 = new PN_Expression(t1_guard_2_expr_1_key, new PN_Operand_Token(new PNToken(this->GetSelf())));
	t1_guard_2->AddExpr(t1_guard_2_expr_1);
	t1_guard_1->SetGuard(t1_guard_2);

	// ---------action-------
	PN_Expression *t1_action_1;
	t1_action_1 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Token(new StringToken("t1 :")));
	t1_action_1->AddResultVar("__primary__");
	t1->AddAction(t1_action_1);

	PN_Expression *t1_action_2;
	t1_action_2 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Var("x"));
	t1_action_2->AddResultVar("__primary__");
	t1->AddAction(t1_action_2);

	PN_Expression *t1_action_3;
	t1_action_3 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Token(new StringToken("\n")));
	t1_action_3->AddResultVar("__primary__");
	t1->AddAction(t1_action_3);

	PN_Expression *t1_action_4;
	t1_action_4 = new PN_Expression(new PN_MessageBin("+", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("x"));
	t1_action_4->AddResultVar("__primary__");
	t1->AddAction(t1_action_4);

	PN_Expression *t1_action_5;
	t1_action_5 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_5->AddResultVar("xx");
	t1->AddAction(t1_action_5);

	PN_Expression *t1_action_6;
	t1_action_6 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("it"));
	t1_action_6->AddResultVar("__primary__");
	t1->AddAction(t1_action_6);

	PN_Expression *t1_action_7;
	t1_action_7 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_7->AddResultVar("itt");
	t1->AddAction(t1_action_7);

//-----------------transition t2 init-----------------
	PN_Transition *t2 = new PN_Transition("t2");
	this->RegisterTransition(t2);

	// ---------preconds-------
	list<PN_Condition *> t2_precond;

	PN_Multiset *t2_preconds_Multiset = new PN_Multiset();
	t2_preconds_Multiset->AddItem(new PN_MultiItemVariable(1, "it"));
	t2_precond.push_back(new PN_Condition(s, t2_preconds_Multiset));
	t2->SetPreconds(t2_precond);

	// ---------postconds-------
	list<PN_Condition *> t2_postcond;

	PN_Multiset *t2_postcondp_Multiset = new PN_Multiset();
	{
		PN_MultiItemList *multiList1 = new PN_MultiItemList(1);
		multiList1->AddItem(new PN_MultiItemVariable(1, "itt"));
		multiList1->AddItem(new PN_MultiItemVariable(1, "xx"));
		t2_postcondp_Multiset->AddItem(multiList1);
	}
	t2_postcond.push_back(new PN_Condition(p, t2_postcondp_Multiset));
	t2->SetPostconds(t2_postcond);

	// --------- guard -------
	PN_Guard *t2_guard_1 = new PN_Guard();
	PN_Expression *t2_guard_1_expr_1;
	t2_guard_1_expr_1 = new PN_Expression(new PN_MessageBin(">", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("it"));
	t2_guard_1->AddExpr(t2_guard_1_expr_1);
	t2->SetGuard(t2_guard_1);

	PN_Guard *t2_guard_2 = new PN_Guard();
	PN_Expression *t2_guard_2_expr_1;
	PN_MessageKeys *t2_guard_2_expr_1_key = new PN_MessageKeys("get2:");
	t2_guard_2_expr_1_key->keys.push_back(new PN_Operand_Var("x"));
	t2_guard_2_expr_1 = new PN_Expression(t2_guard_2_expr_1_key, new PN_Operand_Token(new PNToken(this->GetSelf())));
	t2_guard_2->AddExpr(t2_guard_2_expr_1);
	t2_guard_1->SetGuard(t2_guard_2);

	// ---------action-------
	PN_Expression *t2_action_1;
	t2_action_1 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Token(new StringToken("t2 :")));
	t2_action_1->AddResultVar("__primary__");
	t2->AddAction(t2_action_1);

	PN_Expression *t2_action_2;
	t2_action_2 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Var("x"));
	t2_action_2->AddResultVar("__primary__");
	t2->AddAction(t2_action_2);

	PN_Expression *t2_action_3;
	t2_action_3 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Token(new StringToken("\n")));
	t2_action_3->AddResultVar("__primary__");
	t2->AddAction(t2_action_3);

	PN_Expression *t2_action_4;
	t2_action_4 = new PN_Expression(new PN_MessageBin("+", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("x"));
	t2_action_4->AddResultVar("__primary__");
	t2->AddAction(t2_action_4);

	PN_Expression *t2_action_5;
	t2_action_5 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t2_action_5->AddResultVar("xx");
	t2->AddAction(t2_action_5);

	PN_Expression *t2_action_6;
	t2_action_6 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("it"));
	t2_action_6->AddResultVar("__primary__");
	t2->AddAction(t2_action_6);

	PN_Expression *t2_action_7;
	t2_action_7 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t2_action_7->AddResultVar("itt");
	t2->AddAction(t2_action_7);

//-----------------transition t3 init-----------------
	PN_Transition *t3 = new PN_Transition("t3");
	this->RegisterTransition(t3);

	// ---------preconds-------
	list<PN_Condition *> t3_precond;

	PN_Multiset *t3_precondp_Multiset = new PN_Multiset();
	{
		PN_MultiItemList *multiList1 = new PN_MultiItemList(1);
		multiList1->AddItem(new PN_MultiItemVariable(1, "it"));
		multiList1->AddItem(new PN_MultiItemVariable(1, "x"));
		t3_precondp_Multiset->AddItem(multiList1);
	}
	t3_precond.push_back(new PN_Condition(p, t3_precondp_Multiset));
	t3->SetPreconds(t3_precond);

	// ---------postconds-------
	list<PN_Condition *> t3_postcond;

	PN_Multiset *t3_postconds_Multiset = new PN_Multiset();
	t3_postconds_Multiset->AddItem(new PN_MultiItemVariable(1, "it"));
	t3_postcond.push_back(new PN_Condition(s, t3_postconds_Multiset));
	PN_Multiset *t3_postcondinv_Multiset = new PN_Multiset();
	t3_postcondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "x"));
	t3_postcond.push_back(new PN_Condition(this->GetPlace("inv"), t3_postcondinv_Multiset));
	t3->SetPostconds(t3_postcond);

//-----------------transition tFinal init-----------------
	PN_Transition *tFinal = new PN_Transition("tFinal");
	this->RegisterTransition(tFinal);

	// ---------preconds-------
	list<PN_Condition *> tFinal_precond;

	PN_Multiset *tFinal_preconds_Multiset = new PN_Multiset();
	tFinal_preconds_Multiset->AddItem(new PN_MultiItemVariable(1, "it"));
	tFinal_precond.push_back(new PN_Condition(s, tFinal_preconds_Multiset));
	tFinal->SetPreconds(tFinal_precond);

	// ---------postconds-------
	list<PN_Condition *> tFinal_postcond;

	PN_Multiset *tFinal_postcondreturn_Multiset = new PN_Multiset();
	tFinal_postcondreturn_Multiset->AddItem(new PN_MultiItemVariable(1, "it"));
	tFinal_postcond.push_back(new PN_Condition(_return, tFinal_postcondreturn_Multiset));
	tFinal->SetPostconds(tFinal_postcond);

	// --------- guard -------
	PN_Guard *tFinal_guard_1 = new PN_Guard();
	PN_Expression *tFinal_guard_1_expr_1;
	tFinal_guard_1_expr_1 = new PN_Expression(new PN_MessageBin("<=", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("it"));
	tFinal_guard_1->AddExpr(tFinal_guard_1_expr_1);
	tFinal->SetGuard(tFinal_guard_1);

}

PerformanceTest01_go::~PerformanceTest01_go()
{
	delete s;
	delete _return;
	delete p;
}

