#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20110908

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

#define YYPURE 0

#line 13 "PNtalk.y"
#include <stdio.h>
#include "PNparse.h"
#include <string>
void yyerror(char *);
int yylex(void);
int sym[26];
extern FILE*   yyin;

extern char *yytext;
#define YYDEBUG_LEXER_TEXT yytext

extern int yy_flex_debug;

CppGenerator syntaxTree;

#line 30 "PNtalk.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
int iValue;
char sIndex;
char *strVal;
ClassHead *headPtr;
string *idStr;
pnClassContent *classCont;
pnClassContentHolder *clsContHold;
pnNet *netPtr;
pnPlace *placePtr;
pnTransition *transPtr;
pnCondition *condPtr;
pnMultisetItem *multsetItemPtr;
pnMultiset *multsetPtr;
pnMultisetItemList *multsetListPtr;
pnSetItem * setItemPtr;
Literal *literalPtr;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 61 "t.tab.cpp"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#define YYERROR_DECL() yyerror(const char *s)
#define YYERROR_CALL(msg) yyerror(msg)

extern int YYPARSE_DECL();

#define VARIABLE 257
#define MAIN 258
#define CLASS 259
#define INHERITANCE 260
#define OBJECT 261
#define METHOD 262
#define CONSTRUCTOR 263
#define SYNC 264
#define PLACE 265
#define INIT 266
#define TRANSITION 267
#define COND 268
#define PRECOND 269
#define POSTCOND 270
#define GUARD 271
#define ACTION 272
#define INTEGER 273
#define NUMBER 274
#define DIGIT 275
#define NE 276
#define LT 277
#define GT 278
#define REFEQ 279
#define REFNE 280
#define DIV 281
#define MOD 282
#define ID 283
#define KEYSEL 284
#define SMALLLETTER 285
#define CAPLETTER 286
#define BINSELCHAR 287
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,   26,   26,   27,   27,    1,    2,    2,   11,   11,
   11,   13,    8,    9,   10,   28,   28,   28,   31,   31,
   12,   12,   12,   14,   14,   32,   32,   33,   33,   15,
   16,   16,   17,   17,   18,   18,   19,   19,   29,   29,
   36,   36,   20,   20,   22,   22,   22,   22,   21,   21,
   21,   23,   24,   24,   35,   38,   38,   39,   39,   39,
   41,   42,   42,   43,   44,   44,   45,   46,   47,   47,
   37,   37,   34,   34,   40,   40,   48,   48,   48,   49,
   49,   49,   49,   49,   30,   30,   30,   30,   25,   25,
   25,   25,   25,   25,   51,   52,   53,   53,   53,   53,
   53,    4,    5,    5,    5,    6,    6,    6,   50,   54,
   54,    3,    3,    3,   55,   55,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,
};
static const short yylen[] = {                            2,
    4,    2,    0,    4,    3,    3,    2,    0,    1,    1,
    1,    2,    3,    3,    6,    1,    2,    1,    2,    3,
    2,    2,    0,    6,    5,    4,    0,    1,    2,    7,
    2,    0,    2,    0,    2,    0,    4,    6,    4,    0,
    4,    0,    1,    3,    3,    3,    3,    1,    1,    1,
    1,    3,    1,    3,    3,    2,    0,    1,    1,    3,
    1,    2,    0,    3,    2,    0,    3,    2,    1,    2,
    1,    3,    1,    3,    1,    4,    1,    2,    0,    3,
    4,    2,    3,    1,    1,    1,    2,    2,    1,    1,
    1,    1,    1,    1,    2,    3,    2,    2,    2,    2,
    0,    3,    2,    2,    0,    2,    2,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,
};
static const short yydefred[] = {                         3,
    0,    0,    0,    0,    2,  112,  113,  114,    3,    0,
    0,    0,    0,    0,    0,    0,    5,    9,   10,   11,
    0,    0,    0,    0,    0,   12,    0,    0,    0,   85,
   86,   16,    0,    0,    0,    0,    0,    7,    4,    6,
    0,    0,   21,   22,   19,   13,   87,   88,   17,    0,
   14,    0,    0,    0,    0,   20,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  105,    0,    0,   91,   92,
    0,   48,   43,   51,   49,   93,   94,    0,    0,    0,
    0,    0,    0,    0,    0,   90,   89,   50,   53,    0,
    0,   25,  101,  110,  111,   95,  109,    0,  117,  107,
  108,  118,  125,  126,  123,  124,  120,  134,  133,  132,
  119,  131,  130,  121,  122,  127,  128,  129,  106,    0,
    0,    0,    0,    0,    0,    0,    0,   15,   46,   45,
   52,    0,    0,    0,  102,  104,  103,   47,   24,   44,
    0,    0,   37,    0,    0,   58,   59,    0,    0,   71,
    0,   54,   57,    0,    0,    0,    0,   73,   75,   96,
   98,   97,  100,   99,    0,   30,    0,    0,   39,    0,
    0,   61,    0,   63,   66,   69,    0,   78,    0,    0,
   26,    0,    0,    0,   38,   60,   72,   63,   68,   63,
    0,    0,   70,   55,   56,    0,   74,   41,    0,    0,
   62,    0,   65,    0,   76,    0,    0,
};
static const short yydgoto[] = {                          1,
   10,   17,  154,   69,   98,   70,  119,   18,   19,   20,
   21,   26,   22,   27,   28,   53,   60,  128,   58,   71,
   72,   73,   74,   90,  147,    2,    5,   33,   83,  173,
   35,   92,  155,  156,  157,  142,  148,  179,  149,  158,
  201,  191,  203,  192,  189,  176,  177,  159,  178,   76,
   77,   96,  134,   97,    0,
};
static const short yysindex[] = {                         0,
    0, -202, -186, -186,    0,    0,    0,    0,    0, -194,
 -227, -221, -154,  -44,  -44,  -44,    0,    0,    0,    0,
 -114, -114, -186, -186, -186,    0, -154, -154, -186,    0,
    0,    0, -154,  230, -199, -154, -180,    0,    0,    0,
   55, -180,    0,    0,    0,    0,    0,    0,    0, -186,
    0, -186, -141,  172, -141,    0,   75,   85, -186, -126,
   69,   72,  194, -120,   44,    0,  395,   73,    0,    0,
   62,    0,    0,    0,    0,    0,    0, -126,  210, -186,
   85,   19, -119,  194,  194,    0,    0,    0,    0,   66,
   34,    0,    0,    0,    0,    0,    0,  -31,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  194,
 -120,  210, -101,   86,  132,  462, -186,    0,    0,    0,
    0,  194,  188,   14,    0,    0,    0,    0,    0,    0,
   51, -119,    0,  210,  462,    0,    0,   -3,  221,    0,
   85,    0,    0,  115,   52,  129,  462,    0,    0,    0,
    0,    0,    0,    0,  188,    0,   94,  135,    0,  462,
  462,    0,  165,    0,    0,    0, -106,    0, -124,  118,
    0,  462,  129,   56,    0,    0,    0,    0,    0,    0,
 -186,  -49,    0,    0,    0,  462,    0,    0, -186, -186,
    0,  -49,    0, -106,    0,  -55, -106,
};
static const short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    0,  180,  163,    0,    0,    0,    0,    0,    0,    0,
    3,    3,    0,    0,    0,    0,  163,  163,    0,    0,
    0,    0,  163,    0,   76,  163,   90,    0,    0,    0,
    0,    1,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  104,    0,   31,    0,    0,   16,    0,  124,
   95,   96,    0,  133,    0,    0,    0,  100,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   61,    0,    0,
   46,    0,  170,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,    0,  114,    0,    0,   -2,    0,    0,    0,    0,
    0,    0,   -2,    0,    0,    0,    0,    0,    0,    0,
    0,  143,    0,    0,  141,    0,    0,    0,  -39,    0,
  153,    0,    0,  324,    0,   58,   -2,    0,    0,    0,
    0,    0,    0,    0,   -2,    0,    0,    0,    0,   -2,
    0,    0,    0,    0,    0,    0,  -23,    0,    0,    0,
    0,   -2,   59,    0,    0,    0,    0,    0,    0,    0,
   71,  -20,    0,    0,    0,  -17,    0,    0,   71,  106,
    0,   -9,    0,   -7,    0,  -27,   -6,
};
static const short yygindex[] = {                         0,
    0,   50,  518,  -14,    0,   53,   87,    0,    0,    0,
    0,   98,    0,    0,    0,  144,  134,   48,  -34,  -57,
  -11,   70,    0,    0,  -43,  179,    0,   65,  113,  140,
    0,   74,   28,   37,    0,    0,    0,    0,  -13, -100,
   49,  -24,   54, -133,    0, -129, -143,  -79,    0,    0,
    0,   63,    0,    0,    0,
};
#define YYTABLESIZE 748
static const short yytable[] = {                        194,
   32,   77,    8,  112,  113,   31,   77,  135,  103,  104,
   75,   31,  107,   67,  109,   31,   31,   84,   67,   75,
   82,  124,   84,   79,   81,   82,  110,  118,   79,  111,
   34,   80,   23,   83,   81,   75,   80,    4,   83,   81,
   75,   75,  170,   79,  168,   33,  150,  193,  204,   67,
   95,   89,   66,   93,  160,    3,    4,  202,  207,  114,
   40,  115,  117,  116,  108,  206,   13,   14,   15,   16,
   38,   39,  129,  130,  193,   18,   75,  193,   75,   36,
   37,  197,   66,   93,   50,   77,  167,   52,   75,   32,
  187,  105,  151,  106,   54,  205,    6,   67,    7,    8,
   75,   84,  121,   34,   82,  122,  131,   79,  138,  132,
   24,   66,   25,   42,   79,   80,   66,   83,   81,  162,
  152,  169,   79,   40,   43,   44,  143,   59,   80,  122,
   46,   66,   27,   51,  185,   90,   89,  122,   90,   89,
   50,  126,   36,   50,   82,   91,   64,   14,   15,   16,
  127,   64,   35,   34,   34,   34,  133,  188,    6,  190,
    7,    8,   23,  199,   84,  200,   64,   85,  120,   36,
  141,  144,  180,  165,  182,  186,  181,  171,  196,    1,
  198,   79,   28,   29,  137,   55,  163,   12,   78,  166,
  123,  140,  184,  183,  139,   66,  164,  174,    0,   65,
   67,    0,  175,   66,  145,    0,   65,   67,    0,    0,
   66,   63,   64,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   65,   67,    0,   48,   66,  145,   65,   67,
   64,   30,   66,   63,  171,    0,    0,   30,    6,   29,
    7,    8,   30,   99,   65,   67,    0,    0,   66,   63,
    0,    6,    0,    7,    8,  102,   67,    0,   32,   32,
    8,    8,   32,   32,   32,   32,    0,   32,    0,   32,
   32,   32,   32,   31,   31,    0,    0,   31,   31,   31,
   31,   31,   31,    0,   31,   31,   31,   31,   34,   34,
   48,    0,   34,   34,   34,   34,    6,   34,    7,    8,
   34,   34,   34,   33,   33,    0,    0,   33,   33,   33,
   33,  153,   33,    0,    0,   33,   33,   33,   40,   40,
    0,    0,   40,   40,   40,   40,    6,   40,    7,    8,
   40,    0,   40,   18,   18,    0,    0,   18,   18,   18,
   18,    0,   18,   18,   18,   18,   18,   32,   32,    0,
    0,   32,   32,   32,   66,    0,    0,   66,   32,   32,
   32,   34,   34,    0,   58,   34,   34,   34,    0,   58,
    0,   42,   42,   34,   34,   42,   42,   42,   42,    0,
   42,   40,   40,   42,   58,   40,   40,   40,    0,   64,
   27,   27,   64,   40,   27,   27,   27,   27,    0,   27,
   36,   36,    0,    0,   36,   36,   36,   36,    0,   36,
   35,   35,    0,    0,   35,   35,   35,   35,    0,   35,
   23,   23,    0,    0,   23,   23,   23,   36,   36,  112,
  113,   36,   36,   36,  103,  104,    0,   86,  107,   87,
  109,    0,    0,    0,   61,    0,   62,    6,   58,    7,
    8,   47,  110,  118,    6,  111,    7,    8,    0,    0,
   86,    0,   87,    0,    0,    0,   86,    0,   87,    0,
    6,    0,    7,    8,    0,    0,    6,    0,    7,    8,
    0,    0,   61,    0,   62,  114,    0,  115,  117,  116,
  108,    0,    6,    0,    7,    8,   65,   67,    0,    0,
   66,  145,    0,    6,  171,    7,    8,   30,    0,    0,
    0,    0,    6,    0,    7,    8,   47,  105,    0,  106,
    9,   11,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   32,   32,   32,    0,    0,    0,    0,    0,    0,
   40,   41,   42,    0,    0,    0,   45,    0,    0,    0,
    0,   49,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   56,    0,   57,
    0,   68,    0,    0,    0,    0,   57,    0,    0,    0,
   88,    0,   94,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,  125,    0,    0,
    0,   88,   88,    0,    0,    0,   58,   58,   58,   58,
   58,    0,    0,    0,    0,  136,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   88,    0,   68,
    0,    0,    0,  146,   57,    0,    0,    0,    0,   88,
    0,  161,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,    0,    0,  172,    0,    0,   99,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  100,
  101,  102,    0,    0,    0,    0,    0,  146,  146,    0,
  146,    0,    0,    0,    0,    0,  195,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  172,    0,
    0,    0,    0,    0,    0,    0,  172,  172,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   86,    0,   87,    0,    0,    0,
    0,    0,    0,    0,    6,    0,    7,    8,
};
static const short yycheck[] = {                        124,
    0,   41,    0,   35,   36,   61,   46,   39,   40,   41,
   54,   61,   44,   41,   46,    0,   61,   41,   46,   63,
   41,   79,   46,   41,   59,   46,   58,   59,   46,   61,
    0,   41,  260,   41,   41,   79,   46,  259,   46,   46,
   84,   85,   46,   46,  145,    0,  126,  177,  192,   36,
   65,   63,   39,   40,   41,  258,  259,  191,  202,   91,
    0,   93,   94,   95,   96,  199,  261,  262,  263,  264,
   21,   22,   84,   85,  204,    0,  120,  207,  122,   15,
   16,  182,   39,   40,  284,  125,  144,  268,  132,    0,
  170,  123,  127,  125,   40,  196,  283,  125,  285,  286,
  144,  125,   41,    0,  125,   44,   41,  125,  120,   44,
  265,   41,  267,    0,   40,  125,   46,  125,  125,  134,
  132,  125,  125,    0,   27,   28,   41,  269,   44,   44,
   33,   61,    0,   36,   41,   41,   41,   44,   44,   44,
   41,  123,    0,   44,  271,  266,   41,  262,  263,  264,
  270,   46,    0,   14,   15,   16,  123,  171,  283,  173,
  285,  286,    0,  188,   96,  190,   61,   96,   96,    0,
  272,   40,   58,  123,   46,   41,  125,  284,   61,    0,
  125,   41,  125,  125,   98,   42,  134,    9,   55,  142,
   78,  122,  165,  157,  121,  125,  134,  149,   -1,   35,
   36,   -1,  149,   39,   40,   -1,   35,   36,   -1,   -1,
   39,   40,   41,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   35,   36,   -1,   61,   39,   40,   35,   36,
  125,  287,   39,   40,  284,   -1,   -1,  287,  283,  284,
  285,  286,  287,  275,   35,   36,   -1,   -1,   39,   40,
   -1,  283,   -1,  285,  286,  287,  284,   -1,  258,  259,
  258,  259,  262,  263,  264,  265,   -1,  267,   -1,  269,
  270,  271,  272,  258,  259,   -1,   -1,  262,  263,  264,
  265,   61,  267,   -1,  269,  270,  271,  272,  258,  259,
   61,   -1,  262,  263,  264,  265,  283,  267,  285,  286,
  270,  271,  272,  258,  259,   -1,   -1,  262,  263,  264,
  265,  124,  267,   -1,   -1,  270,  271,  272,  258,  259,
   -1,   -1,  262,  263,  264,  265,  283,  267,  285,  286,
  270,   -1,  272,  258,  259,   -1,   -1,  262,  263,  264,
  265,   -1,  267,  268,  269,  270,  271,  258,  259,   -1,
   -1,  262,  263,  264,  284,   -1,   -1,  287,  269,  270,
  271,  258,  259,   -1,   41,  262,  263,  264,   -1,   46,
   -1,  258,  259,  270,  271,  262,  263,  264,  265,   -1,
  267,  258,  259,  270,   61,  262,  263,  264,   -1,  284,
  258,  259,  287,  270,  262,  263,  264,  265,   -1,  267,
  258,  259,   -1,   -1,  262,  263,  264,  265,   -1,  267,
  258,  259,   -1,   -1,  262,  263,  264,  265,   -1,  267,
  258,  259,   -1,   -1,  262,  263,  264,  258,  259,   35,
   36,  262,  263,  264,   40,   41,   -1,  273,   44,  275,
   46,   -1,   -1,   -1,  273,   -1,  275,  283,  125,  285,
  286,  287,   58,   59,  283,   61,  285,  286,   -1,   -1,
  273,   -1,  275,   -1,   -1,   -1,  273,   -1,  275,   -1,
  283,   -1,  285,  286,   -1,   -1,  283,   -1,  285,  286,
   -1,   -1,  273,   -1,  275,   91,   -1,   93,   94,   95,
   96,   -1,  283,   -1,  285,  286,   35,   36,   -1,   -1,
   39,   40,   -1,  283,  284,  285,  286,  287,   -1,   -1,
   -1,   -1,  283,   -1,  285,  286,  287,  123,   -1,  125,
    3,    4,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   14,   15,   16,   -1,   -1,   -1,   -1,   -1,   -1,
   23,   24,   25,   -1,   -1,   -1,   29,   -1,   -1,   -1,
   -1,   34,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,   52,
   -1,   54,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   63,   -1,   65,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   79,   80,   -1,   -1,
   -1,   84,   85,   -1,   -1,   -1,  283,  284,  285,  286,
  287,   -1,   -1,   -1,   -1,   98,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  120,   -1,  122,
   -1,   -1,   -1,  126,  127,   -1,   -1,   -1,   -1,  132,
   -1,  134,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  144,   -1,   -1,   -1,   -1,  149,   -1,   -1,  275,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,
  286,  287,   -1,   -1,   -1,   -1,   -1,  170,  171,   -1,
  173,   -1,   -1,   -1,   -1,   -1,  179,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  191,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  199,  200,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  273,   -1,  275,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  283,   -1,  285,  286,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 287
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'#'","'$'",0,"'&'","'\\''","'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,
0,0,0,0,0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'","'_'","'`'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VARIABLE",
"MAIN","CLASS","INHERITANCE","OBJECT","METHOD","CONSTRUCTOR","SYNC","PLACE",
"INIT","TRANSITION","COND","PRECOND","POSTCOND","GUARD","ACTION","INTEGER",
"NUMBER","DIGIT","NE","LT","GT","REFEQ","REFNE","DIV","MOD","ID","KEYSEL",
"SMALLLETTER","CAPLETTER","BINSELCHAR",
};
static const char *yyrule[] = {
"$accept : ROOT",
"ROOT : classes MAIN id classes",
"classes : classes class",
"classes :",
"class : CLASS classhead objectnet classcontent",
"class : CLASS classhead classcontent",
"classhead : id INHERITANCE id",
"classcontent : classcontentitem classcontent",
"classcontent :",
"classcontentitem : methodnet",
"classcontentitem : constructor",
"classcontentitem : sync",
"objectnet : OBJECT net",
"methodnet : METHOD message net",
"constructor : CONSTRUCTOR message net",
"sync : SYNC message cond precond guard postcond",
"message : id",
"message : binsel id",
"message : keys",
"keys : KEYSEL id",
"keys : keys KEYSEL id",
"net : place net",
"net : transition net",
"net :",
"place : PLACE id '(' multiset ')' init",
"place : PLACE id '(' ')' init",
"init : INIT '{' actioncontent '}'",
"init :",
"actioncontent : expr_assignment_concat",
"actioncontent : temps expr_assignment_concat",
"transition : TRANSITION id cond precond guard action postcond",
"cond : COND condS",
"cond :",
"precond : PRECOND condS",
"precond :",
"postcond : POSTCOND condS",
"postcond :",
"condS : id '(' multiset ')'",
"condS : condS ',' id '(' multiset ')'",
"guard : GUARD '{' expr_concat '}'",
"guard :",
"action : ACTION '{' actioncontent '}'",
"action :",
"multiset : multisetitem",
"multiset : multiset ',' multisetitem",
"multisetitem : DIGIT '`' c",
"multisetitem : INTEGER '`' c",
"multisetitem : id '`' c",
"multisetitem : c",
"c : literal",
"c : id",
"c : list",
"list : '(' listcontent ')'",
"listcontent : c",
"listcontent : listcontent ',' c",
"temps : '|' tempscontent '|'",
"tempscontent : tempscontent id",
"tempscontent :",
"operand : id",
"operand : literal",
"operand : '(' expr_assignment ')'",
"unaryMsg : id",
"unaryChain : unaryChain unaryMsg",
"unaryChain :",
"binMsg : binsel operand unaryChain",
"binChain : binChain binMsg",
"binChain :",
"keyArg : operand unaryChain binChain",
"keyMsgSegment : KEYSEL keyArg",
"keyMsg : keyMsgSegment",
"keyMsg : keyMsg keyMsgSegment",
"expr_concat : expr",
"expr_concat : expr_concat '.' expr",
"expr_assignment_concat : expr_assignment",
"expr_assignment_concat : expr_assignment_concat '.' expr_assignment",
"expr_assignment : expr",
"expr_assignment : id ':' '=' expr_assignment",
"expr : operand",
"expr : operand msgchain",
"expr :",
"msgchain : unaryMsg unaryChain binChain",
"msgchain : unaryMsg unaryChain binChain keyMsg",
"msgchain : binMsg binChain",
"msgchain : binMsg binChain keyMsg",
"msgchain : keyMsg",
"binsel : BINSELCHAR",
"binsel : '='",
"binsel : binsel BINSELCHAR",
"binsel : binsel '='",
"literal : DIGIT",
"literal : INTEGER",
"literal : string",
"literal : charconst",
"literal : symconst",
"literal : arrayconst",
"arrayconst : '#' array",
"array : '(' arraycontent ')'",
"arraycontent : arraycontent string",
"arraycontent : arraycontent id",
"arraycontent : arraycontent array",
"arraycontent : arraycontent charconst",
"arraycontent :",
"string : '\\'' stringcont '\\''",
"stringcont : stringcont char",
"stringcont : stringcont id",
"stringcont :",
"charconst : '$' char",
"charconst : '$' SMALLLETTER",
"charconst : '$' CAPLETTER",
"symconst : '#' symbol",
"symbol : id",
"symbol : string",
"id : ID",
"id : SMALLLETTER",
"id : CAPLETTER",
"letter : SMALLLETTER",
"letter : CAPLETTER",
"char : DIGIT",
"char : BINSELCHAR",
"char : '='",
"char : ','",
"char : '['",
"char : ']'",
"char : '{'",
"char : '}'",
"char : '('",
"char : ')'",
"char : '_'",
"char : '^'",
"char : ';'",
"char : '$'",
"char : '#'",
"char : ':'",
"char : '.'",
"char : '`'",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 349 "PNtalk.y"

void yyerror(char *s) {
fprintf(stderr, "%s\n", s);
return;
}
int main(void) {
yyin    = fopen("testInput.pn", "r");
yy_flex_debug= 1;
yydebug= 1;
yyparse();
syntaxTree.Print();
return 0;
}
#line 602 "t.tab.cpp"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 71 "PNtalk.y"
	{syntaxTree.startClass = *(yystack.l_mark[-1].idStr); }
break;
case 4:
#line 78 "PNtalk.y"
	{syntaxTree.classes.push_back(new pnClass(yystack.l_mark[-2].headPtr, yystack.l_mark[-1].netPtr, yystack.l_mark[0].classCont)); delete yystack.l_mark[0].classCont;}
break;
case 5:
#line 79 "PNtalk.y"
	{syntaxTree.classes.push_back(new pnClass(yystack.l_mark[-1].headPtr, NULL, yystack.l_mark[0].classCont)); delete yystack.l_mark[0].classCont;}
break;
case 6:
#line 82 "PNtalk.y"
	{ yyval.headPtr = new ClassHead(*(yystack.l_mark[-2].idStr), *(yystack.l_mark[0].idStr));}
break;
case 7:
#line 85 "PNtalk.y"
	{
      yystack.l_mark[0].classCont->contentList.push_back(yystack.l_mark[-1].clsContHold);
      yyval.classCont = yystack.l_mark[0].classCont; }
break;
case 8:
#line 88 "PNtalk.y"
	{yyval.classCont = new pnClassContent();}
break;
case 9:
#line 91 "PNtalk.y"
	{yyval.clsContHold = yystack.l_mark[0].clsContHold;}
break;
case 10:
#line 92 "PNtalk.y"
	{yyval.clsContHold = yystack.l_mark[0].clsContHold;}
break;
case 11:
#line 93 "PNtalk.y"
	{yyval.clsContHold = yystack.l_mark[0].clsContHold;}
break;
case 12:
#line 96 "PNtalk.y"
	{yyval.netPtr = yystack.l_mark[0].netPtr;}
break;
case 13:
#line 99 "PNtalk.y"
	{
      pnClassContentHolder *holder = new pnClassContentHolder;
      holder->type = method;
      holder->contRef = (int *)new pnClassMethod();
      yyval.clsContHold = holder;}
break;
case 14:
#line 106 "PNtalk.y"
	{
      pnClassContentHolder *holder = new pnClassContentHolder;
      holder->type = constructor;
      holder->contRef = (int *)new pnClassMethod();
      yyval.clsContHold = holder;
    }
break;
case 15:
#line 114 "PNtalk.y"
	{
      pnClassContentHolder *holder = new pnClassContentHolder;
      holder->type = port;
      holder->contRef = (int *)new pnClassSync();
      yyval.clsContHold = holder;
    }
break;
case 21:
#line 131 "PNtalk.y"
	{ yystack.l_mark[0].netPtr->AddPlace(yystack.l_mark[-1].placePtr); yyval.netPtr = yystack.l_mark[0].netPtr; }
break;
case 22:
#line 132 "PNtalk.y"
	{ yystack.l_mark[0].netPtr->AddTransition(yystack.l_mark[-1].transPtr); yyval.netPtr = yystack.l_mark[0].netPtr; }
break;
case 23:
#line 133 "PNtalk.y"
	{ yyval.netPtr = new pnNet();}
break;
case 24:
#line 137 "PNtalk.y"
	{yyval.placePtr = new pnPlace(*yystack.l_mark[-4].idStr, yystack.l_mark[-2].multsetPtr);}
break;
case 25:
#line 138 "PNtalk.y"
	{yyval.placePtr = new pnPlace(*yystack.l_mark[-3].idStr, NULL);}
break;
case 26:
#line 141 "PNtalk.y"
	{;}
break;
case 30:
#line 149 "PNtalk.y"
	{yyval.transPtr = new pnTransition(*yystack.l_mark[-5].idStr, yystack.l_mark[-4].condPtr, yystack.l_mark[-3].condPtr, yystack.l_mark[0].condPtr);}
break;
case 31:
#line 152 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[0].condPtr;}
break;
case 32:
#line 153 "PNtalk.y"
	{yyval.condPtr = NULL;}
break;
case 33:
#line 156 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[0].condPtr;}
break;
case 34:
#line 157 "PNtalk.y"
	{yyval.condPtr = NULL;}
break;
case 35:
#line 160 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[0].condPtr;}
break;
case 36:
#line 161 "PNtalk.y"
	{yyval.condPtr = NULL;}
break;
case 37:
#line 164 "PNtalk.y"
	{yyval.condPtr = new pnCondition(*yystack.l_mark[-3].idStr);}
break;
case 38:
#line 165 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[-5].condPtr; yystack.l_mark[-5].condPtr->SetNextCond(new pnCondition(*yystack.l_mark[-3].idStr), true);}
break;
case 43:
#line 176 "PNtalk.y"
	{pnMultiset *result = new pnMultiset(); result->AddItem(yystack.l_mark[0].multsetItemPtr); yyval.multsetPtr = result;}
break;
case 44:
#line 177 "PNtalk.y"
	{ yystack.l_mark[-2].multsetPtr->AddItem(yystack.l_mark[0].multsetItemPtr); yyval.multsetPtr = yystack.l_mark[-2].multsetPtr; }
break;
case 45:
#line 181 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem( yystack.l_mark[0].setItemPtr, yystack.l_mark[-2].iValue);}
break;
case 46:
#line 182 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem( yystack.l_mark[0].setItemPtr, yystack.l_mark[-2].iValue);}
break;
case 47:
#line 183 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem( yystack.l_mark[0].setItemPtr, *yystack.l_mark[-2].idStr);}
break;
case 48:
#line 184 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem(yystack.l_mark[0].setItemPtr, 1);}
break;
case 49:
#line 187 "PNtalk.y"
	{yyval.setItemPtr = new pnSetItem();}
break;
case 50:
#line 188 "PNtalk.y"
	{yyval.setItemPtr = new pnMultisetItemVar(*yystack.l_mark[0].idStr); delete yystack.l_mark[0].idStr;}
break;
case 51:
#line 189 "PNtalk.y"
	{yyval.setItemPtr = yystack.l_mark[0].multsetListPtr;}
break;
case 52:
#line 192 "PNtalk.y"
	{yyval.multsetListPtr = yystack.l_mark[-1].multsetListPtr;}
break;
case 53:
#line 195 "PNtalk.y"
	{ pnMultisetItemList *result = new pnMultisetItemList(); result->AddMItem(yystack.l_mark[0].setItemPtr); yyval.multsetListPtr = result;}
break;
case 54:
#line 196 "PNtalk.y"
	{yystack.l_mark[-2].multsetListPtr->AddMItem(yystack.l_mark[0].setItemPtr); yyval.multsetListPtr = yystack.l_mark[-2].multsetListPtr;}
break;
case 89:
#line 267 "PNtalk.y"
	{IntegerLiteral *res = new IntegerLiteral(); res->Value = yystack.l_mark[0].iValue; yyval.literalPtr = res;}
break;
case 90:
#line 268 "PNtalk.y"
	{IntegerLiteral *res = new IntegerLiteral(); res->Value = yystack.l_mark[0].iValue; yyval.literalPtr = res;}
break;
case 91:
#line 270 "PNtalk.y"
	{StringLiteral *res = new StringLiteral(); res->Value = *yystack.l_mark[0].idStr; delete yystack.l_mark[0].idStr; yyval.literalPtr = res;}
break;
case 92:
#line 271 "PNtalk.y"
	{CharLiteral *res = new CharLiteral(); res->Value = yystack.l_mark[0].sIndex; yyval.literalPtr = res;}
break;
case 93:
#line 272 "PNtalk.y"
	{yyval.literalPtr = new Literal();}
break;
case 94:
#line 273 "PNtalk.y"
	{yyval.literalPtr = new Literal();}
break;
case 102:
#line 294 "PNtalk.y"
	{yyval.idStr = yystack.l_mark[-1].idStr;}
break;
case 103:
#line 297 "PNtalk.y"
	{yystack.l_mark[-1].idStr->append(1, yystack.l_mark[0].sIndex); yyval.idStr = yystack.l_mark[-1].idStr;}
break;
case 104:
#line 298 "PNtalk.y"
	{yystack.l_mark[-1].idStr->append(*yystack.l_mark[0].idStr); delete yystack.l_mark[0].idStr; yyval.idStr = yystack.l_mark[-1].idStr;}
break;
case 105:
#line 299 "PNtalk.y"
	{yyval.idStr = new string();}
break;
case 106:
#line 302 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].sIndex;}
break;
case 107:
#line 303 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].sIndex;}
break;
case 108:
#line 304 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].sIndex;}
break;
case 112:
#line 314 "PNtalk.y"
	{ yyval.idStr = new string(yystack.l_mark[0].strVal);}
break;
case 113:
#line 315 "PNtalk.y"
	{ yyval.idStr = new string(1,yystack.l_mark[0].sIndex);}
break;
case 114:
#line 316 "PNtalk.y"
	{ yyval.idStr = new string(1,yystack.l_mark[0].sIndex);}
break;
case 117:
#line 328 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].iValue + '0';}
break;
case 119:
#line 330 "PNtalk.y"
	{yyval.sIndex = '=';}
break;
case 120:
#line 331 "PNtalk.y"
	{yyval.sIndex = ',';}
break;
case 121:
#line 332 "PNtalk.y"
	{yyval.sIndex = '[';}
break;
case 122:
#line 333 "PNtalk.y"
	{yyval.sIndex = ']';}
break;
case 123:
#line 334 "PNtalk.y"
	{yyval.sIndex = '{';}
break;
case 124:
#line 335 "PNtalk.y"
	{yyval.sIndex = '}';}
break;
case 125:
#line 336 "PNtalk.y"
	{yyval.sIndex = '(';}
break;
case 126:
#line 337 "PNtalk.y"
	{yyval.sIndex = ')';}
break;
case 127:
#line 338 "PNtalk.y"
	{yyval.sIndex = '_';}
break;
case 128:
#line 339 "PNtalk.y"
	{yyval.sIndex = '^';}
break;
case 129:
#line 340 "PNtalk.y"
	{yyval.sIndex = ';';}
break;
case 130:
#line 341 "PNtalk.y"
	{yyval.sIndex = '$';}
break;
case 131:
#line 342 "PNtalk.y"
	{yyval.sIndex = '#';}
break;
case 132:
#line 343 "PNtalk.y"
	{yyval.sIndex = ':';}
break;
case 133:
#line 344 "PNtalk.y"
	{yyval.sIndex = '.';}
break;
case 134:
#line 345 "PNtalk.y"
	{yyval.sIndex = '`';}
break;
#line 1116 "t.tab.cpp"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
