#ifndef PN_CONDITION_H
#define PN_CONDITION_H


#include "PN_Place.h"

class PN_Condition
{
    friend class BindingFinder;
    public:
        PN_Condition(PN_Place *p, PN_Multiset *s, string _name = "");
        virtual ~PN_Condition();
        void DoAsPrecond(list<PN_Binding> bindings);
        void DoAsPostcond(list<PN_Binding> bindings);
    protected:
    private:
        string name;
        PN_Place *targetPlace;
        PN_Multiset *set;
};

#endif // PN_CONDITION_H
