#ifndef PNSIMULATION_H
#define PNSIMULATION_H

#include <list>
#include "PN_Transition.h"

using namespace std;

class PNsimulation
{
    public:
        static PNsimulation* Instance();
        void AddTransitions(PN_Transition* t);
        void Run();
        void ClearDeadTrans();
    private:
        bool alreadyRunning;
        PNsimulation() {alreadyRunning = false;};
        PNsimulation(PNsimulation const&);
        void operator=(PNsimulation const&);
        static PNsimulation* m_Instance;
        list<PN_Transition *> transRegister;
};

#endif // PNSIMULATION_H
