#ifndef PERFORMANCEACKERMANN_H
#define PERFORMANCEACKERMANN_H

#include "PetriNet.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
class PerformanceAckermann: public PN_Class
{
public: 
	PerformanceAckermann();
	virtual ~PerformanceAckermann();
	static PN_MetaClass *GetInstantiator();
	virtual Token *SendMessage(string message, list<PN_Operand*>& args, list<PN_Binding>& binds);
	PN_Place *GetPlace(string placeName);
	string AsText(){return "PerformanceAckermann";}
private:
	PN_Place *start;
	PN_Place *end;
	PN_Place *inv;
};

class PN_MetaClass_PerformanceAckermann: public PN_MetaClass
{
protected: 
	PNToken *GetNewInstance() {return new PNToken(new PerformanceAckermann());}
};


class PerformanceAckermann_x_y_ : public PN_Method_Net
{
public:
	PerformanceAckermann_x_y_ (PN_Class *parentObj, Token *x_Operand, Token *y_Operand);
	virtual ~PerformanceAckermann_x_y_();
private:
	PN_Place *x;
	PN_Place *y;
	PN_Place *r;
	PN_Place_Return *_return;
};
#endif // PERFORMANCEACKERMANN_H
