#ifndef PERFORMANCETEST01_H
#define PERFORMANCETEST01_H

#include "PetriNet.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
#include "PN_Smalltalk.h"
class PerformanceTest01: public PN_Class
{
public: 
	PerformanceTest01();
	virtual ~PerformanceTest01();
	static PN_MetaClass *GetInstantiator();
	virtual Token *SimulateMessage(string message, list<PN_Operand*>& args, list<PN_Binding>& binds);
	virtual Token *SendMessage(string message, list<PN_Operand*>& args, list<PN_Binding>& binds);
	PN_Place *GetPlace(string placeName);
	string AsText(){return "PerformanceTest01";}
private:
	PN_Place *start;
	PN_Place *end;
	PN_Place *inv;
	PN_SyncPort *get1_;
	PN_SyncPort *get2_;
	PN_SyncPort *put_;
};

class PN_MetaClass_PerformanceTest01: public PN_MetaClass
{
protected: 
	PNToken *GetNewInstance() {return new PNToken(new PerformanceTest01());}
};


class PerformanceTest01_go : public PN_Method_Net
{
public:
	PerformanceTest01_go (PN_Class *parentObj);
	virtual ~PerformanceTest01_go();
private:
	PN_Place *s;
	PN_Place_Return *_return;
	PN_Place *p;
};
#endif // PERFORMANCETEST01_H
