#include "PNparse_literals.h"

IntegerLiteral::IntegerLiteral(int value)
{
    Value = value;
}
void IntegerLiteral::Print()
{
    cout << Value;
}


StringLiteral::StringLiteral(string value)
{
    Value = value;
}
void StringLiteral::Print()
{
    cout << Value;
}

SymbolLiteral::SymbolLiteral(string value)
{
   Value = value;
}
void SymbolLiteral::Print()
{
    cout << Value;
}

CharLiteral::CharLiteral(char value)
{
    Value = value;
}
void CharLiteral::Print()
{
    cout << Value;
}

BoolLiteral::BoolLiteral(bool value)
{
    Value = value;
}
void BoolLiteral::Print()
{
    cout << (Value ? "true" : "false");
}

void NilLiteral::Print()
{
    cout << "_nil";
}


