#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20140101

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

#define YYPURE 0

#line 13 "PNtalk.y"
#include <stdio.h>
#include "PNparse.h"
#include "CppGenerator.h"
#include <string>
void yyerror(char *);
int yylex(void);
int sym[26];
extern FILE*   yyin;

extern char *yytext;
#define YYDEBUG_LEXER_TEXT yytext

extern int yy_flex_debug;
#line 28 "PNtalk.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
int iValue;
char sIndex;
char *strVal;
ClassHead *headPtr;
string *idStr;
pnClassContent *classCont;
pnClassContentHolder *clsContHold;
pnNet *netPtr;
pnPlace *placePtr;
pnTransition *transPtr;
pnCondition *condPtr;
pnMultisetItem *multsetItemPtr;
pnMultiset *multsetPtr;
pnMultisetItemList *multsetListPtr;
pnSetItem * setItemPtr;
Literal *literalPtr;
pnAction *actionPtr;
pnExprAssignmentTree *exprTreePtr;
pnMessageUnary *msgUPtr;
pnMessageBinary *msgBPtr;
pnMessageKeys *msgKPtr;
pnOperand *opPtr;
pnLabel *pnLbl;
pnGuard *pnGrd;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 67 "y.tab.cpp"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define VARIABLE 257
#define MAIN 258
#define CLASS 259
#define INHERITANCE 260
#define OBJECT 261
#define METHOD 262
#define CONSTRUCTOR 263
#define SYNC 264
#define PLACE 265
#define INIT 266
#define TRANSITION 267
#define COND 268
#define PRECOND 269
#define POSTCOND 270
#define GUARD 271
#define ACTION 272
#define INTEGER 273
#define NUMBER 274
#define DIGIT 275
#define NE 276
#define LT 277
#define GT 278
#define REFEQ 279
#define REFNE 280
#define DIV 281
#define MOD 282
#define ID 283
#define KEYSEL 284
#define STRING_LITERAL 285
#define SMALLLETTER 286
#define CAPLETTER 287
#define BINSELCHAR 288
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,   46,   46,   47,   47,    1,    2,    2,   15,   15,
   15,   17,   12,   13,   14,   42,   42,   42,   43,   43,
   16,   16,   16,   18,   18,   48,   48,   31,   31,   19,
   20,   20,   21,   21,   22,   22,   23,   23,   44,   44,
   30,   30,   24,   24,   26,   26,   26,   26,   25,   25,
   25,   27,   28,   28,   49,   50,   50,   41,   41,   41,
    7,   36,   36,   37,   38,   38,    9,   39,   40,   40,
   45,   45,   32,   32,   35,   35,   33,   33,   33,   34,
   34,   34,   34,   34,    8,    8,    8,    8,    8,   29,
   29,   29,   29,   29,   29,   51,   52,   53,   53,   53,
   53,   53,    4,   10,   10,   10,    5,    6,    6,    3,
    3,    3,   54,   54,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,
};
static const short yylen[] = {                            2,
    4,    2,    0,    4,    3,    3,    2,    0,    1,    1,
    1,    2,    3,    3,    6,    1,    2,    1,    3,    2,
    2,    2,    0,    6,    5,    4,    0,    1,    2,    7,
    2,    0,    2,    0,    2,    0,    4,    6,    4,    0,
    4,    0,    1,    3,    3,    3,    3,    1,    1,    1,
    1,    3,    1,    3,    3,    2,    0,    1,    1,    3,
    1,    2,    0,    3,    2,    0,    1,    4,    1,    2,
    1,    3,    1,    3,    1,    4,    1,    2,    0,    3,
    4,    2,    3,    1,    1,    1,    1,    2,    2,    1,
    1,    1,    1,    1,    1,    2,    3,    2,    2,    2,
    2,    0,    1,    2,    2,    2,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,
};
static const short yydefred[] = {                         3,
    0,    0,    0,    0,    2,  110,  111,  112,    3,    0,
    0,    0,   23,    0,    0,    0,    5,    9,   10,   11,
    0,    0,    0,    0,   67,   85,   87,   86,   16,    0,
    0,   23,    0,   23,    0,    7,    4,    6,    0,    0,
   21,   22,   88,   89,   17,   20,    0,    0,    0,    0,
    0,    0,    0,   19,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  103,    0,    0,
    0,    0,    0,   92,   94,   93,    0,   48,   43,   51,
   49,   95,    0,    0,    0,    0,    0,   15,    0,    0,
   91,   90,   50,   53,    0,    0,   25,  102,  108,  109,
  107,   96,  115,  105,  106,  116,  123,  124,  121,  122,
  118,  132,  131,  130,  117,  129,  128,  119,  120,  125,
  126,  127,  104,    0,    0,    0,    0,   37,    0,    0,
   58,   59,   71,    0,    0,    0,   46,   45,   52,    0,
    0,    0,   47,   24,   44,    0,    0,    0,    0,   75,
    0,   61,    0,    0,    0,   78,    0,   69,    0,   39,
    0,   54,   57,    0,    0,   73,    0,   97,   99,   98,
  101,  100,    0,   30,   38,    0,   60,    0,    0,    0,
    0,    0,    0,   70,   72,    0,   26,    0,    0,    0,
    0,   62,    0,   64,    0,   65,    0,   55,   56,   74,
   41,   76,    0,   68,
};
static const short yydgoto[] = {                          1,
   10,   17,  149,   74,   75,  101,  178,  154,  155,   76,
  123,   18,   19,   20,   21,   24,   22,   41,   42,   51,
   58,   88,   56,   77,   78,   79,   80,   95,  132,  147,
  164,  165,  150,  156,  166,  179,  182,  183,  158,  159,
  134,   32,   33,   65,  135,    2,    5,   97,  167,  186,
   82,  102,  142,    0,
};
static const short yysindex[] = {                         0,
    0, -128, -242, -242,    0,    0,    0,    0,    0, -192,
 -235, -212,    0,  238,  238,  238,    0,    0,    0,    0,
 -117, -117, -242, -154,    0,    0,    0,    0,    0,  -35,
 -242,    0, -230,    0, -209,    0,    0,    0, -242, -242,
    0,    0,    0,    0,    0,    0, -154, -242, -154, -242,
 -184,   49, -209,    0,   75,  100, -242, -166,  182, -184,
  205, -242,  100,   11, -150,   58,   59,    0,  214, -108,
  227,  -31,   63,    0,    0,    0,   40,    0,    0,    0,
    0,    0, -166,   55,  120,  315, -242,    0,  214,  214,
    0,    0,    0,    0,   65,   38,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  214, -108,  205, -110,    0,  205,  315,
    0,    0,    0,  238,  -46,  100,    0,    0,    0,  214,
  198,  167,    0,    0,    0,   43, -150,   66,  106,    0,
  126,    0, -242,  176,  315,    0,  -42,    0, -230,    0,
  315,    0,    0,   47,  125,    0,  315,    0,    0,    0,
    0,    0,  198,    0,    0,  112,    0, -242,  -42, -242,
 -242,  -42, -230,    0,    0, -118,    0,  315,  125,   50,
  315,    0, -230,    0,  -42,    0, -230,    0,    0,    0,
    0,    0, -230,    0,
};
static const short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    0,  174,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    3,    0,  163,    0,    0,    0,    0,    0,    0,
    0,    0,   76,    0,   90,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  170,    0,  177,    0,
  104,    0,    1,    0,    0,   16,    0,  124,    0,   31,
    0,    0,   46,    0,  184,   88,   94,    0,    0,  133,
    0,    0,   95,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   61,    0,    0,  -32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,    0,  114,    0,    0,  135,
    0,    0,    0,  -34,    0,  143,    0,    0,    0,    0,
  -32,    0,    0,    0,    0,    0,  153,    0,  433,    0,
    0,    0,   81,    0,    0,    0,   -8,    0,  -24,    0,
  -32,    0,    0,    0,   53,    0,  -32,    0,    0,    0,
    0,    0,  -32,    0,    0,    0,    0,   81,   -8,   81,
   81,   -8,  -23,    0,    0,    0,    0,  -32,   54,    0,
  -17,    0,   -9,    0,   -8,    0,   -7,    0,    0,    0,
    0,    0,   -6,    0,
};
static const short yygindex[] = {                         0,
    0,  119,  524,  -60,    0,    0,   48,  134,   34,   39,
    0,    0,    0,    0,    0,   41,    0,    0,    0,  127,
  123,   42,  -36,  -41,  -12,   60,    0,    0,   -3,    0,
   12,   20,  -78,    0,  -88,  -83,   56, -127, -123, -140,
    2,  136,    0,  105,    0,  183,    0,   68,    0,    0,
    0,   52,    0,    0,
};
#define YYTABLESIZE 721
static const short yytable[] = {                        161,
   32,   27,    8,  116,  117,  198,   77,  133,  107,  108,
  100,   77,  111,   79,  113,   31,   84,   82,   28,   84,
   63,   84,   82,   79,   23,   44,  114,  122,   79,  115,
   34,   80,   66,   83,   81,  184,   80,   66,   83,   81,
    6,  151,  197,    7,    8,   33,    4,   31,   31,   31,
  136,  193,  203,   25,  196,   81,   94,   81,   50,  118,
   40,  119,  121,  120,  112,   81,   48,  204,   13,   14,
   15,   16,   47,  184,   49,   18,  137,  138,  160,  184,
  125,  170,  185,  126,   57,   81,   81,  148,   59,   32,
   77,  109,   79,  110,  192,  128,  194,  195,  126,  200,
   84,   82,  202,   34,   64,  139,  175,   79,  140,  126,
   39,  143,   40,   42,   61,   80,   66,   83,   81,   87,
   81,   63,   81,   40,   63,   81,   63,  162,   91,    3,
    4,   91,   27,   86,   90,   50,   81,   90,   50,   36,
   37,   63,   35,   62,   14,   15,   16,   30,   30,   30,
   34,   35,   36,   89,   90,  180,  181,   96,  124,  129,
  141,  146,   12,  176,    6,  173,  177,    7,    8,   13,
  188,  187,  191,    1,  201,   79,   14,   28,   29,   60,
  171,  153,   83,   36,  190,  145,  189,  127,  174,  157,
    0,   12,  144,  172,    0,    0,    0,    0,    0,    0,
    0,    0,   72,    0,    0,   63,   98,  168,    0,    0,
   71,   72,    0,    0,    0,  130,   71,   72,    0,    0,
    0,   69,   70,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   71,   72,    0,    0,   44,  130,    0,   71,
   72,    0,    0,  103,   69,   26,    0,    6,   71,   72,
    7,    8,   43,   69,  104,  105,  106,    0,   32,   32,
    8,    8,   32,   32,   32,   32,   98,   32,    0,   32,
   32,   32,   32,   31,   31,   66,    0,   31,   31,   31,
   31,   27,   31,    0,   31,   31,   31,   31,   34,   34,
    0,    0,   34,   34,   34,   34,    0,   34,   28,    0,
   34,   34,   34,   33,   33,    0,    0,   33,   33,   33,
   33,    0,   33,    0,    0,   33,   33,   33,   40,   40,
    0,  163,   40,   40,   40,   40,    0,   40,    0,    0,
   40,    0,   40,   18,   18,    0,    0,   18,   18,   18,
   18,    0,   18,   18,   18,   18,   18,   32,   32,   71,
   72,   32,   32,   32,  130,    0,    0,    0,   32,   32,
   32,   34,   34,    0,   63,   34,   34,   34,   63,    0,
    0,   42,   42,   34,   34,   42,   42,   42,   42,    0,
   42,   40,   40,   42,    0,   40,   40,   40,    0,    0,
   27,   27,    0,   40,   27,   27,   27,   27,    0,   27,
   35,   35,    0,    0,   35,   35,   35,   35,    0,   35,
   36,   36,    0,    0,   36,   36,   36,   36,    0,   36,
   12,   12,    0,    0,   12,   12,   12,   13,   13,    0,
    0,   13,   13,   13,   14,   14,    0,    0,   14,   14,
   14,   36,   36,    0,    0,   36,   36,   36,   91,    6,
   92,   68,    7,    8,   66,    0,   67,    0,    6,    0,
   68,    7,    8,   43,    6,    0,   68,    7,    8,    0,
   91,    0,   92,   58,    0,    0,   58,   66,   58,   67,
    6,    0,   68,    7,    8,    0,   91,    6,   92,   68,
    7,    8,    0,   58,    0,    0,    6,    0,   68,    7,
    8,    0,    0,    0,    0,    0,    0,    0,    0,    6,
    0,   68,    7,    8,    0,    0,    0,    0,    0,    0,
    6,   25,    0,    7,    8,   26,    9,   11,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   29,   29,   29,
    0,    0,    0,    0,    0,    0,   38,    0,    0,    0,
    0,    0,    0,   45,   46,    0,    0,   58,    0,    0,
    0,    0,   52,   53,    0,    0,    0,    0,    0,    0,
    0,   54,    0,   55,    0,    0,    0,    0,    0,    0,
   55,    0,   73,    0,   73,   85,    0,   91,    0,   92,
    0,    0,   93,    0,   99,    0,    0,    6,    0,   68,
    7,    8,    0,    0,    0,    0,    0,    0,    0,  131,
   55,    0,   93,   93,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   93,    0,   73,
    0,    0,   73,    0,    0,    0,    0,  152,    0,    0,
    0,    0,    0,   93,    0,  169,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  131,  131,    0,
    0,    0,    0,    0,  131,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  152,    0,  152,  152,    0,    0,    0,    0,  199,
    0,    0,    0,    0,    0,   58,   58,    0,   58,   58,
   58,
};
static const short yycheck[] = {                         46,
    0,   44,    0,   35,   36,  124,   41,   86,   40,   41,
   71,   46,   44,   46,   46,    0,   41,   41,   61,   61,
   57,   46,   46,   41,  260,   61,   58,   59,   46,   61,
    0,   41,   41,   41,   41,  159,   46,   46,   46,   46,
  283,  130,  183,  286,  287,    0,  259,   14,   15,   16,
   87,  179,  193,  284,  182,   59,   69,   61,  268,   91,
    0,   93,   94,   95,   96,   69,   33,  195,  261,  262,
  263,  264,   32,  197,   34,    0,   89,   90,  125,  203,
   41,  142,  161,   44,  269,   89,   90,  129,   40,    0,
  125,  123,  125,  125,  178,   41,  180,  181,   44,  188,
  125,  125,  191,    0,  271,   41,   41,  125,   44,   44,
  265,  124,  267,    0,   40,  125,  125,  125,  125,  270,
  124,   41,  126,    0,   44,  129,   46,  140,   41,  258,
  259,   44,    0,  123,   41,   41,  140,   44,   44,   21,
   22,   61,    0,   44,  262,  263,  264,   14,   15,   16,
   15,   16,    0,   96,   96,  154,  155,  266,   96,   40,
  123,  272,    0,   58,  283,  123,   41,  286,  287,    0,
   46,  125,   61,    0,  125,   41,    0,  125,  125,   53,
  142,  134,   60,    0,  173,  126,  167,   83,  147,  134,
   -1,    9,  125,  142,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   36,   -1,   -1,  125,   40,   41,   -1,   -1,
   35,   36,   -1,   -1,   -1,   40,   35,   36,   -1,   -1,
   -1,   40,   41,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   35,   36,   -1,   -1,   61,   40,   -1,   35,
   36,   -1,   -1,  275,   40,  288,   -1,  283,   35,   36,
  286,  287,  288,   40,  286,  287,  288,   -1,  258,  259,
  258,  259,  262,  263,  264,  265,   40,  267,   -1,  269,
  270,  271,  272,  258,  259,  284,   -1,  262,  263,  264,
  265,   44,  267,   -1,  269,  270,  271,  272,  258,  259,
   -1,   -1,  262,  263,  264,  265,   -1,  267,   61,   -1,
  270,  271,  272,  258,  259,   -1,   -1,  262,  263,  264,
  265,   -1,  267,   -1,   -1,  270,  271,  272,  258,  259,
   -1,  124,  262,  263,  264,  265,   -1,  267,   -1,   -1,
  270,   -1,  272,  258,  259,   -1,   -1,  262,  263,  264,
  265,   -1,  267,  268,  269,  270,  271,  258,  259,   35,
   36,  262,  263,  264,   40,   -1,   -1,   -1,  269,  270,
  271,  258,  259,   -1,  284,  262,  263,  264,  288,   -1,
   -1,  258,  259,  270,  271,  262,  263,  264,  265,   -1,
  267,  258,  259,  270,   -1,  262,  263,  264,   -1,   -1,
  258,  259,   -1,  270,  262,  263,  264,  265,   -1,  267,
  258,  259,   -1,   -1,  262,  263,  264,  265,   -1,  267,
  258,  259,   -1,   -1,  262,  263,  264,  265,   -1,  267,
  258,  259,   -1,   -1,  262,  263,  264,  258,  259,   -1,
   -1,  262,  263,  264,  258,  259,   -1,   -1,  262,  263,
  264,  258,  259,   -1,   -1,  262,  263,  264,  273,  283,
  275,  285,  286,  287,  273,   -1,  275,   -1,  283,   -1,
  285,  286,  287,  288,  283,   -1,  285,  286,  287,   -1,
  273,   -1,  275,   41,   -1,   -1,   44,  273,   46,  275,
  283,   -1,  285,  286,  287,   -1,  273,  283,  275,  285,
  286,  287,   -1,   61,   -1,   -1,  283,   -1,  285,  286,
  287,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,
   -1,  285,  286,  287,   -1,   -1,   -1,   -1,   -1,   -1,
  283,  284,   -1,  286,  287,  288,    3,    4,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   14,   15,   16,
   -1,   -1,   -1,   -1,   -1,   -1,   23,   -1,   -1,   -1,
   -1,   -1,   -1,   30,   31,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   39,   40,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   48,   -1,   50,   -1,   -1,   -1,   -1,   -1,   -1,
   57,   -1,   59,   -1,   61,   62,   -1,  273,   -1,  275,
   -1,   -1,   69,   -1,   71,   -1,   -1,  283,   -1,  285,
  286,  287,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   86,
   87,   -1,   89,   90,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,  126,
   -1,   -1,  129,   -1,   -1,   -1,   -1,  134,   -1,   -1,
   -1,   -1,   -1,  140,   -1,  142,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  153,  154,  155,   -1,
   -1,   -1,   -1,   -1,  161,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  178,   -1,  180,  181,   -1,   -1,   -1,   -1,  186,
   -1,   -1,   -1,   -1,   -1,  283,  284,   -1,  286,  287,
  288,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 288
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? (YYMAXTOKEN + 1) : (a))
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'#'","'$'",0,"'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,
0,0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'","'_'","'`'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VARIABLE","MAIN",
"CLASS","INHERITANCE","OBJECT","METHOD","CONSTRUCTOR","SYNC","PLACE","INIT",
"TRANSITION","COND","PRECOND","POSTCOND","GUARD","ACTION","INTEGER","NUMBER",
"DIGIT","NE","LT","GT","REFEQ","REFNE","DIV","MOD","ID","KEYSEL",
"STRING_LITERAL","SMALLLETTER","CAPLETTER","BINSELCHAR","illegal-symbol",
};
static const char *yyrule[] = {
"$accept : ROOT",
"ROOT : classes MAIN id classes",
"classes : classes class",
"classes :",
"class : CLASS classhead objectnet classcontent",
"class : CLASS classhead classcontent",
"classhead : id INHERITANCE id",
"classcontent : classcontentitem classcontent",
"classcontent :",
"classcontentitem : methodnet",
"classcontentitem : constructor",
"classcontentitem : sync",
"objectnet : OBJECT net",
"methodnet : METHOD message net",
"constructor : CONSTRUCTOR message net",
"sync : SYNC message cond precond guard postcond",
"message : id",
"message : binsel id",
"message : keys",
"keys : keys keysel id",
"keys : keysel id",
"net : net place",
"net : net transition",
"net :",
"place : PLACE id '(' multiset ')' init",
"place : PLACE id '(' ')' init",
"init : INIT '{' actioncontent '}'",
"init :",
"actioncontent : expr_assignment_concat",
"actioncontent : temps expr_assignment_concat",
"transition : TRANSITION id cond precond guard action postcond",
"cond : COND condS",
"cond :",
"precond : PRECOND condS",
"precond :",
"postcond : POSTCOND condS",
"postcond :",
"condS : id '(' multiset ')'",
"condS : condS ',' id '(' multiset ')'",
"guard : GUARD '{' expr_concat '}'",
"guard :",
"action : ACTION '{' actioncontent '}'",
"action :",
"multiset : multisetitem",
"multiset : multiset ',' multisetitem",
"multisetitem : DIGIT '`' c",
"multisetitem : INTEGER '`' c",
"multisetitem : id '`' c",
"multisetitem : c",
"c : literal",
"c : id",
"c : list",
"list : '(' listcontent ')'",
"listcontent : c",
"listcontent : listcontent ',' c",
"temps : '|' tempscontent '|'",
"tempscontent : tempscontent id",
"tempscontent :",
"operand : id",
"operand : literal",
"operand : '(' expr_assignment ')'",
"unaryMsg : id",
"unaryChain : unaryMsg unaryChain",
"unaryChain :",
"binMsg : binsel operand unaryChain",
"binChain : binMsg binChain",
"binChain :",
"keysel : KEYSEL",
"keyMsgSegment : keysel operand unaryChain binChain",
"keyMsg : keyMsgSegment",
"keyMsg : keyMsg keyMsgSegment",
"expr_concat : expr",
"expr_concat : expr_concat '.' expr",
"expr_assignment_concat : expr_assignment",
"expr_assignment_concat : expr_assignment_concat '.' expr_assignment",
"expr_assignment : expr",
"expr_assignment : id ':' '=' expr_assignment",
"expr : operand",
"expr : operand msgchain",
"expr :",
"msgchain : unaryMsg unaryChain binChain",
"msgchain : unaryMsg unaryChain binChain keyMsg",
"msgchain : binMsg binChain",
"msgchain : binMsg binChain keyMsg",
"msgchain : keyMsg",
"binsel : BINSELCHAR",
"binsel : '='",
"binsel : ','",
"binsel : binsel BINSELCHAR",
"binsel : binsel '='",
"literal : DIGIT",
"literal : INTEGER",
"literal : string",
"literal : charconst",
"literal : symconst",
"literal : arrayconst",
"arrayconst : '#' array",
"array : '(' arraycontent ')'",
"arraycontent : arraycontent string",
"arraycontent : arraycontent id",
"arraycontent : arraycontent array",
"arraycontent : arraycontent charconst",
"arraycontent :",
"string : STRING_LITERAL",
"charconst : '$' char",
"charconst : '$' SMALLLETTER",
"charconst : '$' CAPLETTER",
"symconst : '#' symbol",
"symbol : id",
"symbol : string",
"id : ID",
"id : SMALLLETTER",
"id : CAPLETTER",
"letter : SMALLLETTER",
"letter : CAPLETTER",
"char : DIGIT",
"char : BINSELCHAR",
"char : '='",
"char : ','",
"char : '['",
"char : ']'",
"char : '{'",
"char : '}'",
"char : '('",
"char : ')'",
"char : '_'",
"char : '^'",
"char : ';'",
"char : '$'",
"char : '#'",
"char : ':'",
"char : '.'",
"char : '`'",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 402 "PNtalk.y"

void yyerror(char *s) {
fprintf(stderr, "%s\n", s);
return;
}
int main(int argc, char* argv[])
{
    char* in = NULL;
    string dir = "output";
    string programName = "";
    for (int i = 1; i < argc; i++)
    {
        if (i + 1 != argc)
        {
            if (string(argv[i]) == "-dir")
            {
                if (i + 1 != argc)
                {
                    dir = argv[i + 1];
                }
                else cout << "Missing argument: Directory must define argument.\n";
            }
            if (string(argv[i]) == "-in")
            {
                cout << "parsing in";
                if (i + 1 != argc)
                {
                    in = argv[i + 1];
                }
                else cout << "Missing argument: Input file not specified.\n";
            }
            if (string(argv[i]) == "-out")
            {
                if (i + 1 != argc)
                {
                    programName = argv[i + 1];
                }
                else cout << "Missing argument: output program name not specified.\n";
            }
        }
        std::cout << "(i = "<< i <<") "<< argv[i] << ", ";

    }

    if (in == NULL)
    {
        cout << "\nInput file not set. Usage: PNTranslator -in inputfile [-dir directoryOutput] [-out programName]\n";
        return 0;
    }

    if (programName == "")
    {
        programName = dir;
    }

    PN_AST_Base *syntaxTree =  new CppGenerator();
    GeneratorImplementation::Instance()->SetImplementation(syntaxTree);
    yyin = fopen(in, "r");
    yy_flex_debug= 1;
    yydebug = 1;

    cout << "parsing...\n";
    yyparse();

    cout << "Printing...\n";
    syntaxTree->Print();

    if (syntaxTree->DoSemantics())
    {
        syntaxTree->GenerateCode(dir, programName);
    }
    delete syntaxTree;
    return 0;
}
#line 668 "y.tab.cpp"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 86 "PNtalk.y"
	{GeneratorImplementation::Instance()->SetStartClass(*(yystack.l_mark[-1].idStr)); }
break;
case 4:
#line 93 "PNtalk.y"
	{GeneratorImplementation::Instance()->AddClass(yystack.l_mark[-2].headPtr, yystack.l_mark[-1].netPtr, yystack.l_mark[0].classCont); delete yystack.l_mark[0].classCont;}
break;
case 5:
#line 94 "PNtalk.y"
	{GeneratorImplementation::Instance()->AddClass(yystack.l_mark[-1].headPtr, NULL, yystack.l_mark[0].classCont); delete yystack.l_mark[0].classCont;}
break;
case 6:
#line 97 "PNtalk.y"
	{ yyval.headPtr = new ClassHead(*yystack.l_mark[-2].idStr, *yystack.l_mark[0].idStr); delete yystack.l_mark[-2].idStr; delete yystack.l_mark[0].idStr; }
break;
case 7:
#line 100 "PNtalk.y"
	{
      yystack.l_mark[0].classCont->contentList.push_back(yystack.l_mark[-1].clsContHold);
      yyval.classCont = yystack.l_mark[0].classCont; }
break;
case 8:
#line 103 "PNtalk.y"
	{yyval.classCont = new pnClassContent();}
break;
case 9:
#line 106 "PNtalk.y"
	{yyval.clsContHold = yystack.l_mark[0].clsContHold;}
break;
case 10:
#line 107 "PNtalk.y"
	{yyval.clsContHold = yystack.l_mark[0].clsContHold;}
break;
case 11:
#line 108 "PNtalk.y"
	{yyval.clsContHold = yystack.l_mark[0].clsContHold;}
break;
case 12:
#line 111 "PNtalk.y"
	{yyval.netPtr = yystack.l_mark[0].netPtr;}
break;
case 13:
#line 114 "PNtalk.y"
	{
      pnClassContentHolder *holder = new pnClassContentHolder;
      holder->type = method;
      holder->contRef = (int *)new pnClassMethod(yystack.l_mark[-1].pnLbl, yystack.l_mark[0].netPtr);
      yyval.clsContHold = holder;}
break;
case 14:
#line 121 "PNtalk.y"
	{
      pnClassContentHolder *holder = new pnClassContentHolder;
      holder->type = constructor;
      holder->contRef = (int *)new pnClassMethod(yystack.l_mark[-1].pnLbl,yystack.l_mark[0].netPtr);
      yyval.clsContHold = holder;
    }
break;
case 15:
#line 129 "PNtalk.y"
	{
      pnClassContentHolder *holder = new pnClassContentHolder;
      holder->type = port;
      holder->contRef = (int *)new pnClassSync(yystack.l_mark[-4].pnLbl, yystack.l_mark[-2].condPtr, yystack.l_mark[-3].condPtr, yystack.l_mark[-1].pnGrd, yystack.l_mark[0].condPtr);
      yyval.clsContHold = holder;
    }
break;
case 16:
#line 137 "PNtalk.y"
	{ pnLabel *lbl = new pnLabel();
        lbl->messageTarget = *yystack.l_mark[0].idStr;
        lbl->messageOriginal = *yystack.l_mark[0].idStr;
        yyval.pnLbl = lbl;
        delete yystack.l_mark[0].idStr; }
break;
case 17:
#line 142 "PNtalk.y"
	{
        pnLabel *lbl = new pnLabel();
        lbl->messageTarget = *yystack.l_mark[-1].idStr;
        lbl->messageOriginal = *yystack.l_mark[-1].idStr;
        lbl->operands.push_back(*yystack.l_mark[0].idStr);
        yyval.pnLbl = lbl;
        delete yystack.l_mark[-1].idStr;
        delete yystack.l_mark[0].idStr; }
break;
case 18:
#line 150 "PNtalk.y"
	{ yyval.pnLbl = yystack.l_mark[0].pnLbl; }
break;
case 19:
#line 153 "PNtalk.y"
	{
        yystack.l_mark[-2].pnLbl->AddOperand(*yystack.l_mark[-1].idStr, *yystack.l_mark[0].idStr);
        yyval.pnLbl = yystack.l_mark[-2].pnLbl;
        delete yystack.l_mark[-1].idStr;
        delete yystack.l_mark[0].idStr; }
break;
case 20:
#line 158 "PNtalk.y"
	{
        pnLabel *lbl = new pnLabel();
        lbl->AddOperand(*yystack.l_mark[-1].idStr, *yystack.l_mark[0].idStr);
        yyval.pnLbl = lbl;
        delete yystack.l_mark[-1].idStr;
        delete yystack.l_mark[0].idStr; }
break;
case 21:
#line 166 "PNtalk.y"
	{ yystack.l_mark[-1].netPtr->AddPlace(yystack.l_mark[0].placePtr); yyval.netPtr = yystack.l_mark[-1].netPtr; }
break;
case 22:
#line 167 "PNtalk.y"
	{ yystack.l_mark[-1].netPtr->AddTransition(yystack.l_mark[0].transPtr); yyval.netPtr = yystack.l_mark[-1].netPtr; }
break;
case 23:
#line 168 "PNtalk.y"
	{ yyval.netPtr = new pnNet();}
break;
case 24:
#line 172 "PNtalk.y"
	{yyval.placePtr = new pnPlace(*yystack.l_mark[-4].idStr, yystack.l_mark[-2].multsetPtr); delete yystack.l_mark[-4].idStr;}
break;
case 25:
#line 173 "PNtalk.y"
	{yyval.placePtr = new pnPlace(*yystack.l_mark[-3].idStr, NULL); delete yystack.l_mark[-3].idStr; }
break;
case 26:
#line 176 "PNtalk.y"
	{;}
break;
case 28:
#line 180 "PNtalk.y"
	{yyval.actionPtr = yystack.l_mark[0].actionPtr;}
break;
case 29:
#line 181 "PNtalk.y"
	{yyval.actionPtr = yystack.l_mark[0].actionPtr;}
break;
case 30:
#line 184 "PNtalk.y"
	{yyval.transPtr = new pnTransition(*yystack.l_mark[-5].idStr, yystack.l_mark[-3].condPtr, yystack.l_mark[-4].condPtr, yystack.l_mark[-2].pnGrd, yystack.l_mark[-1].actionPtr, yystack.l_mark[0].condPtr);delete yystack.l_mark[-5].idStr;}
break;
case 31:
#line 187 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[0].condPtr;}
break;
case 32:
#line 188 "PNtalk.y"
	{yyval.condPtr = NULL;}
break;
case 33:
#line 191 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[0].condPtr;}
break;
case 34:
#line 192 "PNtalk.y"
	{yyval.condPtr = NULL;}
break;
case 35:
#line 195 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[0].condPtr;}
break;
case 36:
#line 196 "PNtalk.y"
	{yyval.condPtr = NULL;}
break;
case 37:
#line 199 "PNtalk.y"
	{yyval.condPtr = new pnCondition(*yystack.l_mark[-3].idStr, yystack.l_mark[-1].multsetPtr);delete yystack.l_mark[-3].idStr;}
break;
case 38:
#line 200 "PNtalk.y"
	{yyval.condPtr = yystack.l_mark[-5].condPtr; yystack.l_mark[-5].condPtr->SetNextCond(new pnCondition(*yystack.l_mark[-3].idStr, yystack.l_mark[-1].multsetPtr), true);}
break;
case 39:
#line 203 "PNtalk.y"
	{yyval.pnGrd = yystack.l_mark[-1].pnGrd;}
break;
case 40:
#line 204 "PNtalk.y"
	{yyval.pnGrd = NULL;}
break;
case 41:
#line 207 "PNtalk.y"
	{yyval.actionPtr = yystack.l_mark[-1].actionPtr;}
break;
case 42:
#line 208 "PNtalk.y"
	{yyval.actionPtr = NULL;}
break;
case 43:
#line 211 "PNtalk.y"
	{pnMultiset *result = new pnMultiset(); result->AddItem(yystack.l_mark[0].multsetItemPtr); yyval.multsetPtr = result;}
break;
case 44:
#line 212 "PNtalk.y"
	{ yystack.l_mark[-2].multsetPtr->AddItem(yystack.l_mark[0].multsetItemPtr); yyval.multsetPtr = yystack.l_mark[-2].multsetPtr; }
break;
case 45:
#line 215 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem( yystack.l_mark[0].setItemPtr, yystack.l_mark[-2].iValue);}
break;
case 46:
#line 216 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem( yystack.l_mark[0].setItemPtr, yystack.l_mark[-2].iValue);}
break;
case 47:
#line 217 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem( yystack.l_mark[0].setItemPtr, *yystack.l_mark[-2].idStr);}
break;
case 48:
#line 218 "PNtalk.y"
	{ yyval.multsetItemPtr = new pnMultisetItem(yystack.l_mark[0].setItemPtr, 1);}
break;
case 49:
#line 221 "PNtalk.y"
	{yyval.setItemPtr = GeneratorImplementation::Instance()->CreateMultisetItemLiteral(yystack.l_mark[0].literalPtr);}
break;
case 50:
#line 222 "PNtalk.y"
	{yyval.setItemPtr = GeneratorImplementation::Instance()->CreateMultisetItemVar(*yystack.l_mark[0].idStr); delete yystack.l_mark[0].idStr;}
break;
case 51:
#line 223 "PNtalk.y"
	{yyval.setItemPtr = yystack.l_mark[0].multsetListPtr;}
break;
case 52:
#line 226 "PNtalk.y"
	{yyval.multsetListPtr = yystack.l_mark[-1].multsetListPtr;}
break;
case 53:
#line 229 "PNtalk.y"
	{ pnMultisetItemList *result = GeneratorImplementation::Instance()->CreateMultisetItemList(); result->AddMItem(yystack.l_mark[0].setItemPtr); yyval.multsetListPtr = result;}
break;
case 54:
#line 230 "PNtalk.y"
	{yystack.l_mark[-2].multsetListPtr->AddMItem(yystack.l_mark[0].setItemPtr); yyval.multsetListPtr = yystack.l_mark[-2].multsetListPtr;}
break;
case 58:
#line 240 "PNtalk.y"
	{yyval.opPtr = GeneratorImplementation::Instance()->CreateOperandVar(*yystack.l_mark[0].idStr); delete yystack.l_mark[0].idStr;}
break;
case 59:
#line 241 "PNtalk.y"
	{yyval.opPtr = GeneratorImplementation::Instance()->CreateOperandToken(yystack.l_mark[0].literalPtr);}
break;
case 60:
#line 242 "PNtalk.y"
	{
      try
      {
	yyval.opPtr = new pnOperandExpr(yystack.l_mark[-1].exprTreePtr);
      }
      catch (runtime_error ex)
      {
        cerr << ex.what();
      }
    }
break;
case 61:
#line 255 "PNtalk.y"
	{yyval.idStr = yystack.l_mark[0].idStr;}
break;
case 62:
#line 258 "PNtalk.y"
	{yyval.msgUPtr = GeneratorImplementation::Instance()->CreateUnaryMessage(*yystack.l_mark[-1].idStr, yystack.l_mark[0].msgUPtr); delete yystack.l_mark[-1].idStr; }
break;
case 63:
#line 259 "PNtalk.y"
	{yyval.msgUPtr = NULL;}
break;
case 64:
#line 262 "PNtalk.y"
	{yyval.msgBPtr = GeneratorImplementation::Instance()->CreateBinaryMessage(*yystack.l_mark[-2].idStr, yystack.l_mark[-1].opPtr, yystack.l_mark[0].msgUPtr);}
break;
case 65:
#line 265 "PNtalk.y"
	{yystack.l_mark[-1].msgBPtr->SetNextMsg(yystack.l_mark[0].msgBPtr); yyval.msgBPtr = yystack.l_mark[-1].msgBPtr;}
break;
case 66:
#line 266 "PNtalk.y"
	{yyval.msgBPtr = NULL;}
break;
case 67:
#line 269 "PNtalk.y"
	{yyval.idStr = new string(yystack.l_mark[0].strVal);}
break;
case 68:
#line 272 "PNtalk.y"
	{
      yyval.msgBPtr = GeneratorImplementation::Instance()->CreateBinaryMessage(*yystack.l_mark[-3].idStr, yystack.l_mark[-2].opPtr, yystack.l_mark[-1].msgUPtr); yyval.msgBPtr->SetNextMsg(yystack.l_mark[0].msgBPtr);
      delete yystack.l_mark[-3].idStr;
    }
break;
case 69:
#line 278 "PNtalk.y"
	{yyval.msgKPtr = GeneratorImplementation::Instance()->CreateKeysMessage(); yyval.msgKPtr->AddKey(yystack.l_mark[0].msgBPtr);}
break;
case 70:
#line 279 "PNtalk.y"
	{yyval.msgKPtr = yystack.l_mark[-1].msgKPtr; yyval.msgKPtr->AddKey(yystack.l_mark[0].msgBPtr);}
break;
case 71:
#line 282 "PNtalk.y"
	{yyval.pnGrd = new pnGuard(); yyval.pnGrd->AddExpr(yystack.l_mark[0].exprTreePtr);}
break;
case 72:
#line 283 "PNtalk.y"
	{ yyval.pnGrd = yystack.l_mark[-2].pnGrd; yyval.pnGrd->AddExpr(yystack.l_mark[0].exprTreePtr);}
break;
case 73:
#line 286 "PNtalk.y"
	{yyval.actionPtr = new pnAction(); yyval.actionPtr->AddExprTree(yystack.l_mark[0].exprTreePtr); }
break;
case 74:
#line 287 "PNtalk.y"
	{yyval.actionPtr = yystack.l_mark[-2].actionPtr; yystack.l_mark[-2].actionPtr->AddExprTree(yystack.l_mark[0].exprTreePtr);}
break;
case 75:
#line 290 "PNtalk.y"
	{yyval.exprTreePtr = yystack.l_mark[0].exprTreePtr;}
break;
case 76:
#line 291 "PNtalk.y"
	{yystack.l_mark[0].exprTreePtr->AddResultVar(*yystack.l_mark[-3].idStr); delete yystack.l_mark[-3].idStr; yyval.exprTreePtr = yystack.l_mark[0].exprTreePtr;}
break;
case 77:
#line 294 "PNtalk.y"
	{yyval.exprTreePtr = new pnExprAssignmentTree(NULL, NULL, NULL); yyval.exprTreePtr->SetOperand(yystack.l_mark[0].opPtr);}
break;
case 78:
#line 295 "PNtalk.y"
	{yyval.exprTreePtr = yystack.l_mark[0].exprTreePtr; yyval.exprTreePtr->SetOperand(yystack.l_mark[-1].opPtr);}
break;
case 79:
#line 296 "PNtalk.y"
	{yyval.exprTreePtr = NULL;}
break;
case 80:
#line 299 "PNtalk.y"
	{
        pnMessageUnary *uMsg = GeneratorImplementation::Instance()->CreateUnaryMessage(*yystack.l_mark[-2].idStr, yystack.l_mark[-1].msgUPtr);
        delete yystack.l_mark[-2].idStr;
        yyval.exprTreePtr = new pnExprAssignmentTree(uMsg, yystack.l_mark[0].msgBPtr, NULL);
    }
break;
case 81:
#line 304 "PNtalk.y"
	{
        pnMessageUnary *uMsg = GeneratorImplementation::Instance()->CreateUnaryMessage(*yystack.l_mark[-3].idStr, yystack.l_mark[-2].msgUPtr);
        delete yystack.l_mark[-3].idStr;
        yyval.exprTreePtr = new pnExprAssignmentTree(uMsg, yystack.l_mark[-1].msgBPtr, yystack.l_mark[0].msgKPtr);
    }
break;
case 82:
#line 309 "PNtalk.y"
	{yystack.l_mark[-1].msgBPtr->SetNextMsg(yystack.l_mark[0].msgBPtr); yyval.exprTreePtr = new pnExprAssignmentTree(NULL, yystack.l_mark[-1].msgBPtr, NULL);}
break;
case 83:
#line 310 "PNtalk.y"
	{yystack.l_mark[-2].msgBPtr->SetNextMsg(yystack.l_mark[-1].msgBPtr); yyval.exprTreePtr = new pnExprAssignmentTree(NULL, yystack.l_mark[-2].msgBPtr, yystack.l_mark[0].msgKPtr);}
break;
case 84:
#line 311 "PNtalk.y"
	{yyval.exprTreePtr = new pnExprAssignmentTree(NULL, NULL, yystack.l_mark[0].msgKPtr);}
break;
case 85:
#line 315 "PNtalk.y"
	{yyval.idStr = new string(1, yystack.l_mark[0].sIndex);}
break;
case 86:
#line 316 "PNtalk.y"
	{yyval.idStr = new string(1, '=');}
break;
case 87:
#line 317 "PNtalk.y"
	{yyval.idStr = new string(1, ',');}
break;
case 88:
#line 318 "PNtalk.y"
	{ yystack.l_mark[-1].idStr->append(1, yystack.l_mark[0].sIndex); yyval.idStr = yystack.l_mark[-1].idStr;}
break;
case 89:
#line 319 "PNtalk.y"
	{ yystack.l_mark[-1].idStr->append(1, '='); yyval.idStr = yystack.l_mark[-1].idStr;}
break;
case 90:
#line 322 "PNtalk.y"
	{yyval.literalPtr = GeneratorImplementation::Instance()->CreateMultisetItemInt(yystack.l_mark[0].iValue);}
break;
case 91:
#line 323 "PNtalk.y"
	{yyval.literalPtr = GeneratorImplementation::Instance()->CreateMultisetItemInt(yystack.l_mark[0].iValue);}
break;
case 92:
#line 325 "PNtalk.y"
	{yyval.literalPtr = GeneratorImplementation::Instance()->CreateMultisetItemString(*yystack.l_mark[0].idStr); delete yystack.l_mark[0].idStr;}
break;
case 93:
#line 326 "PNtalk.y"
	{yyval.literalPtr = GeneratorImplementation::Instance()->CreateMultisetItemChar(yystack.l_mark[0].sIndex);}
break;
case 94:
#line 327 "PNtalk.y"
	{yyval.literalPtr = GeneratorImplementation::Instance()->CreateMultisetItemSymbol(*yystack.l_mark[0].idStr); delete yystack.l_mark[0].idStr;}
break;
case 95:
#line 328 "PNtalk.y"
	{yyval.literalPtr = NULL;}
break;
case 103:
#line 349 "PNtalk.y"
	{yyval.idStr = new string(yystack.l_mark[0].strVal);
        yyval.idStr->erase(yyval.idStr->begin());
        yyval.idStr->erase(yyval.idStr->end()-1);
        }
break;
case 104:
#line 355 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].sIndex;}
break;
case 105:
#line 356 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].sIndex;}
break;
case 106:
#line 357 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].sIndex;}
break;
case 107:
#line 360 "PNtalk.y"
	{yyval.idStr = yystack.l_mark[0].idStr;}
break;
case 108:
#line 363 "PNtalk.y"
	{yyval.idStr = yystack.l_mark[0].idStr;}
break;
case 109:
#line 364 "PNtalk.y"
	{yyval.idStr = yystack.l_mark[0].idStr;}
break;
case 110:
#line 367 "PNtalk.y"
	{ yyval.idStr = new string(yystack.l_mark[0].strVal);}
break;
case 111:
#line 368 "PNtalk.y"
	{ yyval.idStr = new string(1,yystack.l_mark[0].sIndex);}
break;
case 112:
#line 369 "PNtalk.y"
	{ yyval.idStr = new string(1,yystack.l_mark[0].sIndex);}
break;
case 115:
#line 381 "PNtalk.y"
	{yyval.sIndex = yystack.l_mark[0].iValue + '0';}
break;
case 117:
#line 383 "PNtalk.y"
	{yyval.sIndex = '=';}
break;
case 118:
#line 384 "PNtalk.y"
	{yyval.sIndex = ',';}
break;
case 119:
#line 385 "PNtalk.y"
	{yyval.sIndex = '[';}
break;
case 120:
#line 386 "PNtalk.y"
	{yyval.sIndex = ']';}
break;
case 121:
#line 387 "PNtalk.y"
	{yyval.sIndex = '{';}
break;
case 122:
#line 388 "PNtalk.y"
	{yyval.sIndex = '}';}
break;
case 123:
#line 389 "PNtalk.y"
	{yyval.sIndex = '(';}
break;
case 124:
#line 390 "PNtalk.y"
	{yyval.sIndex = ')';}
break;
case 125:
#line 391 "PNtalk.y"
	{yyval.sIndex = '_';}
break;
case 126:
#line 392 "PNtalk.y"
	{yyval.sIndex = '^';}
break;
case 127:
#line 393 "PNtalk.y"
	{yyval.sIndex = ';';}
break;
case 128:
#line 394 "PNtalk.y"
	{yyval.sIndex = '$';}
break;
case 129:
#line 395 "PNtalk.y"
	{yyval.sIndex = '#';}
break;
case 130:
#line 396 "PNtalk.y"
	{yyval.sIndex = ':';}
break;
case 131:
#line 397 "PNtalk.y"
	{yyval.sIndex = '.';}
break;
case 132:
#line 398 "PNtalk.y"
	{yyval.sIndex = '`';}
break;
#line 1393 "y.tab.cpp"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = yyname[YYTRANSLATE(yychar)];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
